#
/*	preprocessor for cdc card image files
*/



#define MAXCARDS 12	/* max number of cards to read */
#define LPMAX	133	/* max # of chars on a lpt line */
#define	DPMAX	1200	/* max number of chars to read from dp w/o sync */
#define NLEGAL	6	/* # of different msgs from c.s. to ut */
#define	ERRESP	6	/* the small integer dpread returns upon error */
#define	ERRESP2	7	/* the small integer representing dpread's
			   return upon zero characters received from dp*/
#define DWRNUM	4	/* small int rep. diag write from dpread */

#define	E1BCD	0102
#define E1ASC	0042
#define E1	0102	/* asc/bcd E1 for write, E1 for read */
#define	E2	040
#define	E3	041
#define LOGEOF	'@'
#define LOGEOR	'%'
#define PUNEOF	0224
#define PUNEOR	0024
#define INTEOF	034
#define INTEOR	036
#define SPC0	'+'	/* suppress spaces: no line advance */
#define	SPC2	'0'	/* double space */
#define PGEJCT	'1'	/* page eject */
#define	SOH	001
#define	SYNC	026
#define	ZERO	060
#define	SPC	040
#define	FF	014
#define	CR	015
#define	LF	012
#define	ACK	006
#define	ETX	003
#define	REJECT	030
#define	ERR	025
#define	READ	023
#define	ESC	033
#define CLEARPA	012	/* clear page char (clear write) */
#define	RESETPA	013	/* vertical tab (reset write) */

char	cl;		/* character which clears */
char	rpa;		/* character which homes to beg of page */

char	dprbuf[DPMAX];
char	dpibuf[DPMAX];
int	dpocnt;	/* must be just above dpobuf */
char	dpobuf[DPMAX];
char	lpbuf[134];
char	membuf[DPMAX];
char	crbuf[DPMAX];
char	spbuf[6];
char	kbbuf[82];

/* holders for dp, cr and lp channels */

int	dpchn;
int	crchn;
int	lpchn;
int	debugchn;

int	crcount;
int	crcol81;
int	crlfsw;

int	kbcount;

int	parercd;	/* ascii or extbcd core for parity error */
int	crcd;		/* ascii or extbcd code for <cr> */
int	eolcd;		/* ascii or extbcd code for <eol> */
int	esccd;		/* ascii or extbcd code for <esc> */
int	eofcd;		/* ascii or extbcd codes for eof,eor */
int	eorcd;

char	*dppnt;
char	*dplast;
char	*dprpnt;
char	*dprlast;


char	initflg;
char	pending;	/* set on READ, cleared on next WRITE */
int	kbstat[3];	/* vec for keybord gtty */
char	kblockf;	/* key board lock flag */
char	kbintf;		/* break hit on keyboard */
char	kbmsgf;		/* have message to send to central site */
char	crmsgf;		/* have cards to send to central site */
char	autordf;	/* set after write to printer (E2,E3) */
char	asciif;		/* communicating in ASCII */
char	escapf;		/* xmit or dpic do not conv following char */

/* flags to indicate that device has been opened */

char	lpopenf;
char	cropenf;

char	station;	/* station addr that came in from c.s. */
char	effstn;		/* effective staton (flip flop) */
char	siteadr;	/* 160 or 170 depending on args to UT */
char	lpc;		/* longitudinal parity check */


#include "cdctab.c"

int	(*dsptbl[])() {
	&regwrt,	/* write:	141,161 */
	&regwrt,	/* r-write:	141,161 */
	&regwrt,	/* c-write:	141,161 */
	&alertfn,	/* alert:	141,161 */
	&diagwrt,	/* diagwrite:	140,141,160,161 */
	&polmsg,	/* poll:	140,160 */
	&errmsg,	/* any bad code */
	&timerr,	/* no characters received on read */
};

int	lglcode[6];
char	*infile;
char	outfile[32];

main(argc, argv)
int argc;
char **argv;
{
	register c;
	register chr;
	char *na, *nb;

	nice(-100);
	cl = CLEARPA;
	rpa = RESETPA;
	lglcode[0]=021;
	lglcode[1]=014;
	lglcode[2]=022;
	lglcode[3]=07;
	lglcode[5]=05;

	siteadr = 0160;
	asciif = 0;
	while (--argc > 0 && **++argv == '-') {
	  switch(c = *++*argv) {
		case 'i':
			argv++;
			infile = *argv;
			--argc;
			na = *argv;
			nb = outfile;
			while(*nb = *na++) nb++;
			na = ".cdc";
			while(*nb++ = *na++);
			continue;

		case 'a':
			asciif++;
			continue;
		case 'b':
			asciif = 0;
			continue;
		case 'd':
			debugchn = creat("debugfile",0666);
			continue;
		default:
			if ('0'<=c && c<='7') {
				siteadr = 0;
				do
					siteadr = siteadr*8 + c-'0';
				while ('0'<=(c = *++*argv) && c<='7');
				if (0160<=siteadr && siteadr<=0177) continue;
			}
			printf("illegal switch %s\n", *argv);
			exit();
	  }
	}

	if(infile == 0) {
		infile = "cardfile";
		na = "cardtemp";
		nb = outfile;
		while(*nb++ = *na++);
	}
	if(asciif) {
		lglcode[4] = 024;
		parercd = 040;
		crcd = 0101;
		eolcd = 0100;
		esccd = 033;
		eofcd = 0126;
		eorcd = 0127;
	} else {
		lglcode[4] = 020;
		parercd = 0120;
		crcd = 0101;
		eolcd = 0120;
		esccd = 076;
		eofcd = 0126;
		eorcd = 0127;
	}

/* process card images as if being sent to cdc */

	crchn = open(infile, 0);
	if(crchn<0) {
		perror(infile);
		exit();
	}
	dpchn = creat(outfile,0666);
	if(dpchn<0) {
		perror(outfile);
		exit();
	}

	for(;;) {
		crcount = 0;
		for (chr=0; chr<MAXCARDS; chr++) {
			if((c = rdcard( &crbuf[crcount] )) == 0)
				break;
			crcount =+ c;
		}
		crread();
		if(crcount == 0) break;
	}
	write(1,"\n",1);
}

dpread()
{
	register c;
	register char *rp,*ip;
	int p;

beg:
	if (dprpnt >= dprlast) {
reread:		c = read(dpchn, dprpnt=dprbuf, DPMAX);
		if (c <= 0)
			return(ERRESP2);
		c =+ &dprbuf[-1];
		dprlast = c;
	}
	else {	/* more than one msg read by dp */
		printf("\n[extra msg at %o]\n", dprpnt);
	}

	rp = dprpnt;
	ip = dppnt = &dpibuf[0];
	for(;;) {
		if (rp >= dprlast) {
			write(1,"[read late]\n",12);
			if (debugchn)
				write(debugchn,dprpnt,rp-dprpnt+1);
			goto reread;
		}
		if (((*ip++ = *rp++)&0377) == (ETX | 0200)) break;
	}
	*ip = *rp++;
	if (debugchn)
		write(debugchn,dprpnt,rp-dprpnt);
	dprpnt = rp;
	dplast = ip;

resync:
	while((c = dpic()) != SOH && c != -1);
	if(c < 0)
		goto beg;
	lpc = c;
	if(dpic() != siteadr)
		goto beg;
	station = dpic();
	if (initflg==0)
		write(1,"[communications established]\n",29);
	initflg=1;
	if((station & ~021) != 0140 || (c=dpic()) < 0)
		return(ERRESP);
	kbcheck();
	for(p=0; p<NLEGAL; p++)
		if(c==lglcode[p])
			if((p>DWRNUM && (station&01)) ||
			   (p<DWRNUM && (station&01)==0))
				break;
			else
				return(p);
	return(ERRESP);
}
tdpic()
{
	register c, par;

	if(dppnt > dplast)
		return(-1);
	c = *dppnt++;
	c =& 0377;
	par = c;
	par =& ~lpc;
	lpc =& ~c;
	lpc =| par;
	par = c;
	c =& 0177;
	par =& 0200;
	if((chartab[c]&0200) != par)
		return(-2);
	if(escapf) {
		escapf = 0;
		return(c);
	}
	if(asciif==0)
		c = bcdasc[c]&0177;
	if(c==ESC)
		escapf++;
	return(c);
}


dpic()
{
	register c, par;

	if(dppnt > dplast)
		return(-1);
	c = *dppnt++;
	c =& 0377;
	par = c;
	par =& ~lpc;
	lpc =& ~c;
	lpc =| par;
	par = c;
	c =& 0177;
	par =& 0200;
	if((chartab[c]&0200) != par)
		return(-2);
	return(c);
}

regwrt(msg)
{
	register char *cp, *cp1;
	register c;
	char *cpsave;
	char nbeglin;
	int chr;

	cp = membuf;
	cp1 = cp;
	cpsave = cp;
loop:
	while((c = tdpic()) != ESC)
		if(c < 0) {
			shortmsg(ERR, 0);
			return;
		} else
			if(c)
				*cp++ = c;
	c=tdpic(); /*know that previous char was an ESC: get next one */
	switch(c) {
case E1BCD:
case E1ASC:
		if(qack()) {
			pending = 0;
			kblockf = 0;
			autordf = 0;
			if(kbintf) {
				crmsgf = 0;
				kbmsgf = 1;
			}
			if (msg==2)
				write(1,&cl,1);
				else if (msg==1)
					write(1,&rpa,1);
			while(cp1 < cp)
				if(*cp1++ == 0) {
					if((c = *cp1)==crcd)
						c = LF;
					cp1[-1] = c;
					write(1, cpsave, cp1-cpsave);
					cpsave = ++cp1;
				}
			if (cp1-cpsave) {
				write(1,cpsave,cp1-cpsave);
				write(1,"\n-----\n",7);
			}
		}
		return;
case E2:
		if(geteom()) {
			shortmsg(ERR, 1);
			return;
		}
		effstn = station;
		if(lpopenf==0) {
			if((lpchn = creat("lpfile", 0644)) < 0) {
				shortmsg(REJECT, 1);
				write(1,"create error on lpfile\n",24);
				return;
			}
			lpopenf++;
		}
		shortmsg(ACK, 1);
		pending = 0;
		cpsave = cp;
		cp = lpbuf;
		nbeglin = 0;
		while(cp1 < cpsave) {
			if((c = *cp1++) && (cp < &lpbuf[LPMAX-1]))
				if(nbeglin==0) {
					if(asciif) c = ascbcd[c];
					switch (c) {
				case PGEJCT:	*cp++ = FF;
				case SPC0:	nbeglin=1; break;
				case SPC2:	*cp++ = LF;
				default:	*cp++ = LF;
						nbeglin=1;
					}
				}
				else {
					if('A'<=c && c<='Z')
						c = c-'A'+'a';
					*cp++ = c;
				}
			else {
				if(((c = *cp1++)==crcd) || (c == eolcd)) {
					*cp++ = CR;
					if (write(lpchn,lpbuf,cp-lpbuf) != cp-lpbuf)
						write(1,"lp write error\n",16);
					cp = lpbuf;
					nbeglin=0;
				} else {
					if((c&040)==040)
						if((c =& 037) >= 3)
							chr = SPC;
						else
							continue;
					else
						if(((c&0140) == 0100) && ((c =& 037) >= 3)
						  && (c <  020))
							chr = ZERO;
						else
							continue;
					while(cp < &lpbuf[LPMAX-1] && c--)
						*cp++ = chr;
				}
			}
		}
		if(cp-lpbuf) {
			write(lpchn,lpbuf,cp-lpbuf);
			write(lpchn,"\r",1);
		}
		autordf = E3;
		write(1,">",1);
		return;
case E3:
		if(qack()) {
			pending = 0;
			kbmsgf = 0;
			crmsgf = 1;
			autordf = 0;
			kblockf = 1;
			if(cropenf==0) {
				if((crchn=open(infile, 0)) < 0)
					return;
				cropenf++;
			}
			crcount = 0;
			for (chr=0; chr<MAXCARDS; chr++) {
				if((c = rdcard( &crbuf[crcount] )) == 0)
					break;
				crcount =+ c;
			}
		}
		return;
default:
		*cp++ = 0;
		*cp++ = c;
		goto loop;
	}
}


shortmsg(code, lobit)
{

	register char *cp;

	cp = &dpobuf[4];
	*cp++ = SOH;
	*cp++ = siteadr;
	if (effstn == 0) effstn=0160;
	*cp++ = (effstn & ~01) | lobit;
	*cp++ = code;
	*cp++ = ETX;
	xmit();
}

autoread()
{
	register char *cp;

	cp = &dpobuf[4];
	*cp++ = SOH;
	*cp++ = siteadr;
	*cp++ = effstn;
	*cp++ = READ;
	*cp++ = ESC;
	*cp++ = autordf;
	*cp++ = ETX;
	xmit();
}

xmit()
{

	register c, par;
	register char *cp;
	int	count, escf;

	cp = dpobuf;
	while(*cp != SOH)
		*cp++ = SYNC;
	par = 0;
	escf = 0;
	count=0;
	do {
		c = *cp;
		c =& 0177;
		if ((count++ >= 4) && (asciif==0) && !escf) {
			if(c==ESC) escf++;
			c = ascbcd[c];
			*cp = c;
		} else {
			escf = 0;
			if(chartab[c]&0200)
				*cp =| 0200;
		}
		c =& ~par;
		par =& ~*cp;
		par =| c;
	} while (((*cp++)&0377) != (ETX|0200));
	c = ~par & 0177;
	*cp++ = c | (chartab[c]&0200);
	if(cp&01)
		*cp++ = SYNC;
	dpocnt = cp - dpobuf;
	if(dpocnt>1024)
		printf("%d char message\n",dpocnt);
	if((count = write(dpchn, &dpocnt, 1024)) != 1024)
		printf("\n[write err %o]\n", count);
}

rexmit()
{
	int count;
	if((count = write(dpchn, dpobuf, dpocnt)) != dpocnt)
		printf("\n[rewrt err %o]\n",count);
	if (debugchn) write(debugchn, dpobuf, dpocnt);
}

polmsg()
{
	if (geteom() == 0) {
		if(pending) {
			if (dpobuf[7] != READ && dpobuf[8] != READ) {
				printf("\nrexmit of %o %o\n", dpobuf[7],dpobuf[8]);
				return;
			}
			rexmit();
			write(1,"\"",1);
			return;
		}
		if(autordf) {
			autoread();
			pending = 3;
			return;
		}
		if(kbmsgf) {
			kbmsgf = 0;
			kbread();
			pending = 1;
		} else
			if(crmsgf) {
				crmsgf = 0;
				crread();
				pending = 2;
			} else
				shortmsg(REJECT,0);
	} else {
		shortmsg(ERR,1);
	}

}

diagwrt()
{
	register char *cp;
	register c;

	cp = &dpobuf[4];
	*cp++ = SOH;
	*cp++ = siteadr;
	*cp++ = station | 01;
	*cp++ = READ;
	write(1,"[dw]\n",5);
	while ((c=dpic()) != ETX)
		if(c>=0)
			*cp++ = c;
		else
			if(c== -2)
				*cp++ = parercd;
			else
				break;
	*cp++ = ETX;
	typbuf(&dpobuf[8],cp);
	xmit();
}

qack()
{
	if (geteom() == 0) {
		effstn = station;
		shortmsg(ACK,1);
		return(1);
	}
	shortmsg(ERR,1);
	return(0);
}

geteom()
{
	register c,p;

	while((c = dpic()) >= 0 && c != ETX);
	if(c >= 0 && (p=dpic()) >= 0 && (lpc & 0177) == 0177)
		return(0);
	else if (((lpc & 0177) == 0151) && (p == -2))
		return(0);
	else
		return(-1);
	/* sync xor 0177 = 0151 */
}


kbcheck()
{
	register n;

	if (gtty(0, kbstat)) return;
	if (kbstat[1] == 0)  return;
	do {
		n = read(0,kbbuf,82);
		if (n == 0)
			exit(); /* temporary exit facility */
	} while (kbbuf[--n] != LF);
	kbcount=n;
	if (n == 0) {
		kbintf = kbmsgf = 0;
	}
	else {
		if(kblockf)
			kbintf++;
		else
			kbmsgf++;
	}
}


kbread()
{
	register char *cp, *cp1;
	register n;

	effstn=0161;
	kbintf=0;
	cp = &dpobuf[4];
	if((kbcount&01)==0)
		*cp++ = 0;
	*cp++ = SOH;
	*cp++ = siteadr;
	*cp++ = effstn;
	*cp++ = READ;
	if(n=kbcount) {
		cp1 = kbbuf;
		do
			if ((*cp1 <= 122) && (*cp1 >= 97))
				*cp++ = (*cp1++ & 0337);
					else *cp++ = *cp1++;
		while(--n);
		kbcount = 0;
	}
	*cp++ = ESC;
	*cp++ = E1;
	*cp++ = ETX;
	xmit();
	write(1,"^",1);
}

crread()
{
	register char *cp, *cp1;
	register n;

	effstn = 0141;
	autordf=0;
	cp = &dpobuf[4];
	*cp++ = 0;
	*cp++ = SOH;
	*cp++ = siteadr;
	*cp++ = effstn;
	*cp++ = READ;
	n=crcount;
	cp1 = crbuf;
	if(n)
		do
			{
			if ((*cp1 == INTEOF)||(*cp1 == INTEOR)) {
			    *cp++ = ESC;
			    *cp1 = (*cp1 == INTEOF ? eofcd:eorcd);
			}
			else if ('a' <= *cp1 && *cp1 <= 'z')
			    *cp1 = *cp1 -'a' +'A';
			*cp++ = *cp1++;
			}
		while(--n);
	*cp++ = ESC;
	if(crcount == 0)
		*cp++ = E2;
	else
		*cp++ = E3;
	*cp++ = ETX;
	xmit();
	write(1,"<",1);
}
disp(msgtype)
{
	(*dsptbl[msgtype])(msgtype);
}

alertfn() {
	if (qack()) write(1,"[alert]\n",8);
}


typbuf(b,endb)
	char *b;
	char *endb;
{
	register c;
	register char *cp1;

	dppnt=b;
	dplast=endb;
	cp1=membuf;
	for ( ; ; ) {
		c = dpic();
		if (c < 0) break;
		if (c == ESC) {
			if ((c = dpic()) == CR)
				c=LF;
			if ((c == (asciif?E1ASC:E1BCD)) || (c == E2) || (c == E3))
				c='#';
		}
		*cp1++ = c;
	}
	*cp1++ = LF;
	write(1,membuf,cp1-membuf);
}
rdcard(b)
	char *b;
{
	register int col;
	register char c;
	register char *bb;
	int n;
	char chr;
	char lbuf[81];

  begcard:
	bb = b;
	col=0;
	while(col++ < 80) {
		n = read(crchn, &chr, 1);
		if (n == 0) 
			if (col != 1) goto endcard;
			else return(0);
		c = chr;
		if (crcol81) {
			crcol81 = 0;
			if (c == LF) goto begcard;
			if (crlfsw) {
				seek(crchn, -81, 1);
				read(crchn, lbuf, 81);
				write(1,lbuf, 81);
				write(1, "\n...long line\n", 14);
			}
		}
		if (c == '\t') {
			while ((col & 07) != 00) {  *bb++ = SPC; col++; }
			c = SPC;
		}
		if (c == LF) {
			crlfsw++;
 endcard:		while (col++ < 81)
				*bb++ = SPC;
			return(80);
		}
		if (col == 1)
		  { if (c == LOGEOF || (c&0377) == PUNEOF) c = INTEOF;
		    else if (c == LOGEOR || (c&0377) == PUNEOR) c = INTEOR;
		  }
		*bb++ = c;
	}
	crcol81++;
	return(80);
}

errmsg()
{
	shortmsg(ERR,1);
}

timerr()
{
	write(1,"[timeout: enter \"y\" to retry] ",30);
	read(0,spbuf,6);
	if (spbuf[0]=='y')
		return;
		else exit();
}
