#
/*
 *	Edx  -  sub-process to ED
 *	Mark Pearson  -  IIASA August 1976
 *	Currently supports Hazeltine 1200 and Hazeltine Modular One.
 *	Our tty driver is funny so cntl-shift-L produces '\', and the like
 *	   for other H1200 'cannot generate in tpwr mode' chars: []^_@
 *	Must reside in /etc/edx
 */
#include	"edsys.h"
#define SAVEMAX		25
#define MAXLINES	(DISPLAY + SAVEMAX)	/* Must be >= DISPLAY + SAVEMAX */
#define BYTSIZ		(LINLEN + 2)		/* Cannot be < LINLEN + 2 */
#define TABSIZ		8
#define SCRNLEN		23			/* Physical screen - 1 */
#define SCRNWID		79			/* Physical screen - 1 */
#define LRSHIFT		(TABSIZ * 2)
#define QSIZE		32
/* Hazeltine 1200 Dependent Codes */
#define H1200HME	013
#define H1200CLR	014
#define H1200DESTBL	020
/* Modular One Dependent Codes */
#define M1DWN		013
#define M1UP		014
#define M1POSN		021
#define M1HME		022
#define M1CLR		034
#define M1DESTBL	040
#define M1TYPE1		042
#define M1CLRKEY	0134
#define M1CURS		0140
#define M1LEADIN	0176
/* Cursor Movement Commands */
#define TOP		007
#define BACKSP		010
#define LF		012
#define CUP		013
#define CLEAR		014
#define RIGHT		014
#define RETURN		015
#define EOL		016
#define LWORD		017
#define RWORD		020
#define RUBOUT		0177
/* All Other Commands  */
#define UNDO		000
#define RSHIFT		001
#define MINUSPG		002
#define ARG		003
#define RMWORD		004
#define MINUSLINE	005
#define RMCHAR		006
#define ED		021
#define REPAINT		022
#define LSHIFT		023
#define MKLINE		024
#define RMLINE		025
#define PLUSPG		026
#define PLUSLINE	027
#define RESTORE		030
#define INSERT		031
#define NOT_SEEN	032
#define SAVE		033
#define NOT_SEEN	034 - 037

char	**savetabl[10];
char	*clostabl[SAVEMAX];
char	*corend;
char	*freelist[MAXLINES];
char	*nextfree;
char	*sbuf;
char	*worksp[MAXLINES];
char	argbuf[SCRNWID];
char	blank	040;
char	bytbuf[BYTSIZ];
char	destbl	H1200DESTBL;
char	oldline[LINLEN+2];
char	readq[QSIZE];
char	savchar;
char	screen[SCRNLEN+1][SCRNWID+1];
char	srchbuf[SCRNWID];
int	arg;
int	baseline;
int	bytcnt;
int	changed;
int	coffset;
int	column;
int	edimode;
int	edtty[3];
int	freecnt;
int	insertg		1;
int	lastsave;
int	line;
int	linecnt;
int	modone;
int	oldbasel;
int	oldlnum;
int	oldnarg;
int	pipin;
int	pipout;
int	qcnt;
int	qsub;
int	rmlincnt;
int	savcolumn;
int	savecnt[10];
int	savline;
int	showing;
int	walwd;
int	workcol;
int	xedtty[3];

main(argc,argv)
char **argv;
{
	register f, t;
	register char c;

	setup(argc,argv);
	setexit();
	wcolocat();
	arg = 0;
	for(;;) {
		c = xread();
		savline = line;
		savcolumn = column;
		savchar = screen[line][column];
		arg = 0;
		if((c >= 040 && c < 0177) || c == TAB) achar(c);

		else if((c >= TOP && c <= RWORD) || c == 0177) cmove(c);

		else {
			mainswitch:
			switch(c) {	/* Commands */

				case ED:
					ed();
					break;

				case ARG:
					if((c = getarg()) == ARG) {
						posn(savline,savcolumn);
						if(screen[line][column] != savchar) {
							wbyt(savchar);
							wbyt(BACKSP);
						}
						arg = 0;
						continue;
					}
					arg++;
					goto mainswitch;

				case PLUSPG:
					if(arg) baseline =+ numrcarg(argbuf) * (SCRNLEN + 1);
					else baseline =+ SCRNLEN + 1;
					askedit(0);
					display(0);
					posn(savline, savcolumn);
					break;

				case MINUSPG:
					if(arg) baseline =- numrcarg(argbuf) * (SCRNLEN + 1);
					else baseline =- SCRNLEN + 1;
					askedit(0);
					display(0);
					posn(savline, savcolumn);
					break;

				case LSHIFT:
					if(coffset == LINLEN - SCRNWID + 1) {
						bell();
						break;
					}
					t = coffset;
					if(arg) {
						f = numrcarg(argbuf);
						f = f - (f%TABSIZ);
						coffset =+ f;
						f = savcolumn - f;
					} else {
						coffset =+ LRSHIFT;
						f = savcolumn - LRSHIFT;
					}
					if(coffset > LINLEN - SCRNWID + 1) coffset = LINLEN - SCRNWID + 1;
					display(0);
					if(f < 1) f = 1;
					if(t != coffset) posn(savline,f);
					break;

				case RSHIFT:
					t = coffset;
					if(arg) {
						f = numrcarg(argbuf);
						f = f - (f%TABSIZ);
						coffset =- f;
						f = savcolumn + f;
					} else {
						coffset =- LRSHIFT;
						f = savcolumn + LRSHIFT;
					}
					if(coffset < 0) coffset = 0;
					display(0);
					if(f >= SCRNWID) f = SCRNWID - 1;
					if(t == coffset) f = savcolumn;
					posn(savline,f);
					break;

				case PLUSLINE:
					if(arg) {
						baseline =+ numrcarg(argbuf);
						f = savline - numrcarg(argbuf);
					} else {
						baseline =+ savline;
						f = 0;
					}
					askedit(0);
					display(0);
					if(f < 0) f = 0;
					posn(f,savcolumn);
					break;

				case MINUSLINE:
					t = baseline;
					if(arg) {
						baseline =- numrcarg(argbuf);
						f = savline + numrcarg(argbuf);
					} else {
						baseline =- SCRNLEN - savline;
						f = SCRNLEN;
					}
					askedit(0);
					display(0);
					if(f >= SCRNLEN) f = SCRNLEN;
					if(t != baseline) posn(f,savcolumn);
					break;

				case RMWORD:
					if(arg) rmword(numrcarg(argbuf));
					else rmword(1);
					break;

				case MKLINE:
					if(arg) mkline(t = numrcarg(argbuf));
					else mkline(t = 1);
					display(0);
					posn(savline,0);
					break;

				case RMLINE:
					rmline();
					break;

				case INSERT:
					if(arg) posn(savline,savcolumn);
					insertg = !insertg;
					break;

				case RMCHAR:
					if(arg) {
						posn(savline,savcolumn);
						if(t = numrcarg(argbuf)) rmchar(t);
						else rmchar(-1);
					} else rmchar(0);
					break;

				case SAVE:
					save(0);
					break;

				case RESTORE:
					restore();
					break;

				case REPAINT:
					display(1);
					posn(savline,savcolumn);
					break;

				case UNDO:
					if(arg) numrcarg(argbuf);
					t = column;
					if(oldlnum != line) {
						bell();
						break;
					}
					copyline(oldline,0,worksp[line]);
					display(0);
					posn(savline,t);
					break;

				case LF:
					pickbuf();
					fwdsrch(0);
					break;

				case RETURN:
					pickbuf();
					fwdsrch(1);
					break;

				case CUP:
					pickbuf();
					bkwdsrch();
					break;

				default:
					break;

			}
			arg = 0;
			curtrol();
			continue;
		}
		if(column == 0 && coffset == 0) {
			wbyt(blank);
			wcolocat();
		}
	}
}

achar(cc)
char cc;
{
	register char c;
	register t, l;

	if(column >= SCRNWID || !walwd) {
		bell();
		return;
	}
	if(line >= linecnt) {
		l = line;
		for(t = linecnt; t <= l; t++) {
			if(worksp[t] == 0) assign(worksp,t);
			if(coffset) c = '<';
			else c = '|';
			if(screen[t][0] != c) {
				posn(t, 0);
				wbyt(c);
			}
		}
		restposn();
		linecnt = l + 1;
		wcolocat();
	}
	c = cc;
	changed++;
	if(line != oldlnum) {
		oldlnum = line;
		copyline(worksp[oldlnum],0,oldline);
	}
	if(c == '\\') {
		wbyt(c);
		wbyt(BACKSP);
		c = xread();
		switch(c) {
			case '\\':
				break;

			case '(':
				c = '{';
				break;

			case ')':
				c = '}';
				break;

			case '!':
				c = '|';
				break;

			case '\'':
				c = '`';
				break;

			case '^':
				c = '~';
				break;

			default:
				if(c == LF || c == RETURN) break;
				if(c < 040) {
					insert(QUOTE);
					c =+ 0100;
					break;
				}
				if(insertg) insert('\\');
				else overwrit('\\');
				wcolocat();
				break;
		}
		if(insertg) insert(c);
		else overwrit(c);
		return;
	}
	if(insertg) insert(0);
	else overwrit(c);
}

overwrit(c)
char c;
{
	register cl;

	changed++;
	cl = column;
	worksp[line][workcol] = c;
	if(wline(line)) posn(line,cl+1);
	curtrol();
}

insert(c)
{
	register char *count;	/* Sometimes */
	register char *j, *i;
	char ch, *input;
	int stp, p, col;


	stp = 0;
	count = 1;
	changed++;

	repeat:
	if((col = column) >= SCRNWID) {
		bell();
		return;
	}
	i = j = &worksp[line][workcol];
	while(*j++);
	if(j >= &worksp[line][LINLEN]) {
		bell();
		return;
	}
	p = count;
	count =+ j;
	while(j >= i) *--count = *--j;

	count = p;

	if(c) {
		stp++;
		worksp[line][workcol] = c;
	} else {
		input = &readq[qsub - count]; 
		while(--p >= 0) worksp[line][workcol++] = *input++;
	}
	p = count;
	if(wline(line)) posn(line, col + 1);;
	curtrol();
	while(--p > 0) {
		wbyt(blank);
		curtrol();
	}
	if(stp) return;
	count = 0;
	if(qsub == qcnt) {
		if((ch = xread()) < 040 || ch > 0176 || ch == '\\') {
			--qsub;
			return;
		} else count = 1;
	}
	while(qsub < qcnt)
		if((ch = xread()) >= 040 && ch <= 0176 && ch != '\\') count++;
		else {
			--qsub;
			stp++;
			break;
	}
	if(count > 0) goto repeat;
}

cmove(cc)
char cc;
{
	register char c, s;
	register t;

	c = cc;
	switch(c) {
		case BACKSP:
		case RUBOUT:
			t = column;
			do {
				wbyt(BACKSP);
				wcolocat();
			} while(showing > column && column > 0);
			curtrol();
			if(c == BACKSP || !insertg) break;
			if(t <= 1) {
				bell();
				break;
			}
			rmchar(1);
			break;

		case TOP:
			posn(0,1);
			break;

		case RETURN:
			t = line + 1;
			posn(t, 1);
			curtrol();
			break;

		case CUP:
			posn(line - 1,column);
			break;

		case LF:
			wbyt(LF);
			break;

		case RIGHT:
			if(column >= SCRNWID) break;
			if(line >= linecnt) break;
			if(worksp[line][workcol] != TAB) {
				wbyt(blank);
				break;
			}
			t = TABSIZ - ((column - 1) % TABSIZ);
			posn(line, column + t);
			break;

		case RWORD:
			rword();
			curtrol();
			break;

		case LWORD:
			lword();
			curtrol();
			break;

		case EOL:
			if(line < linecnt)
				while(worksp[line][workcol] && column < SCRNWID) cmove(RIGHT);
			curtrol();
			break;

	}
	wcolocat();
}

wcolocat()
{
	register t;
	register char *wl;

	if(line < linecnt) {
		wl = worksp[line];
		for(t = 0; t < column+coffset-1; ) {
			if(*wl == TAB) {
				t =+ (TABSIZ - (t%TABSIZ));
				wl++;
			} else if(*wl++ == 0) {
				--wl;
				break;
			} else t++;
		}
		workcol = wl - worksp[line];
	} else t = workcol = 0;
	if(t < coffset) showing = 0;
	else if(t == coffset) showing = 1;
	else showing = (++t) - coffset;
	if(column == showing) walwd = 1;
	else walwd = 0;
}

curtrol()
{
	wcolocat();
	posn(line,showing);
	wcolocat();
}

wline(lin)
{
	register char *wl, *sl;
	register t;
	char c;
	int tabbing, sline;

	sl = screen[(sline = lin)];
	if(lin >= linecnt) c = '-';
	else if(coffset) c = '<';
	else c = '|';
	if(c != *sl++) {
		posn(lin, 0);
		wbyt(c);
	}
	tabbing = 0;
	if(lin >= linecnt) {
		for(t = 1; t < SCRNWID; t++) {
			if(*sl++ != destbl) {
				posn(sline,t);
				wbyt(destbl);
			}
		}
		return(1);
	}

	wl = worksp[lin];
	for(t = 0; t < LINLEN; t++) {
		if(--tabbing > 0) c = destbl;
		else if(*wl == TAB) {
			tabbing = TABSIZ - (t%TABSIZ);
			c = destbl;
			wl++;
		} else c = *wl++;
		if(c == QUOTE) c = '^';
		else if(c == LF || c == RETURN) {
			savline = lin + 1;
			if(savline >= linecnt) {
				release(worksp,savline);
				assign(worksp,savline);
				linecnt++;
			} else mkline(1);
			copyline(worksp[lin],wl - worksp[lin],worksp[lin+1]);
			--wl;
			while(*wl) *wl++ = 0;
			display(0);
			posn(lin + 1, 1);
			return(0);
		}
		if(t >= coffset) {
			if(c == blank || c == 0) c = destbl;
			if(*sl++ != c) {
				posn(sline,t-coffset+1);
				wbyt(c);
			}
		}
		if(t >= coffset+SCRNWID-2) goto retend;
	}
	retend:
	if(sline == SCRNLEN && modone) return(1);
	if(*wl != 0) c = '>';
	else c = destbl;
	if(screen[sline][SCRNWID] != c) {
		posn(sline, SCRNWID);
		wbyt(c);
	}
	return(1);
}

wbyt(cc)
char cc;
{
	register char c;

	if(bytcnt >= BYTSIZ) dbyt();
	c = cc;
	if(c >= 041 && c <= 0176) {
		bytbuf[bytcnt++] = screen[line][column++] = c;
		if(modone && c == M1LEADIN) bytbuf[bytcnt-1] = '`';

	} else  switch(c) {

		case H1200DESTBL:
		case M1DESTBL:
			bytbuf[bytcnt++] = c;
			if(c == destbl) screen[line][column] = c;
			column++;
			break;

		case TAB:
			screen[line][column++] = bytbuf[bytcnt++] = destbl;
			break;

		case LF:
			if(line == SCRNLEN) break;
			bytbuf[bytcnt++] = c;
			line++;
			break;

		case BACKSP:
			if(column == 0) break;
			bytbuf[bytcnt++] = c;
			--column;
			break;

		case RETURN:
			bytbuf[bytcnt++] = c;
			column = 0;
			break;

		case TOP:
			line = column = 0;
			bytbuf[bytcnt++] = H1200HME;
			break;

		case CLEAR:
			if(!modone) bytbuf[bytcnt++] = H1200CLR;
			else {
				wctl(M1LEADIN);
				wctl(M1CLR);
			}
			break;

		default:
			screen[line][column++] = bytbuf[bytcnt++] = destbl;
			break;
	}
	if(column > SCRNWID) {
		if(modone) posn(line, SCRNWID);
		else column = SCRNWID;
	}
	if(bytcnt >= BYTSIZ) dbyt();
}

wctl(cc)
{
	if(bytcnt >= BYTSIZ) dbyt();
	bytbuf[bytcnt++] = cc;
}
rword()
{
	register char *sl;
	register i, typ;
	char *l;

	if(line >= linecnt) return;
	sl = screen[line];
	l = worksp[line];
	typ = type(sl[column]);
	for(;;) {
		for(i = column; column < SCRNWID && type(sl[i]) == typ && l[workcol] != 0; i++) {
			wbyt(blank);
			wcolocat();
		}
		typ = type(sl[i]);
		if(typ != 0 || l[workcol] == 0) return;
	}
}

type(cc)
char cc;
{
	register char c;

	if((c = cc) == blank || c == destbl || c == TAB) return(0);
	if((c >= '0' && c <= '9') || (c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) return(1);
	return(-1);
}

lword()
{
	register char *l;
	register typ, i;

	l = screen[line];
	if(line >= linecnt) return;
	typ = type(l[i = column]);
	if(typ && type(l[i - 1]) == typ) {
		while(type(l[--i]) == typ);
		posn(line,++i);
		return;
	}
	for(;;) {
		typ = type(l[--i]);
		if(typ == 0) while(i > 0 && type(l[i]) == 0) --i;
		typ = type(l[i]);
		while(i > 0 && type(l[i]) == typ) --i;
		if(typ || i <= 0) break;
	}
	posn(line,++i);
}

rmword(cnt)
{
	register typ, wc;
	register char *l;
	int t, count;

	l = worksp[line];
	if(l == 0 || l[wc = workcol] == 0) {
		bell();
		return;
	}
	if(cnt <= 0) cnt = 1;
	count = 0;
	while(cnt--) {
		typ = type(l[wc]);
		for(t = 0; l[wc] != 0 && type(l[wc]) == typ; t++) wc++;
		count =+ t;
	}
	rmchar(count);
}

setup(argc,argv)
char **argv;
{
	register char *b;
	register f;
	struct { char lo; char hi; };
	signal(2,1);
	signal(3,1);
	if(argc != 3) exit(-1);
	pipout = argv[2][0] - 'c';
	pipin = argv[2][1] - 'c';
	nextfree = sbrk(LINLEN * DISPLAY);
	corend = sbrk(0);
	gtty(1,edtty);
	if((f = (edtty[2] >> 9 & 07)) == 2) modone++;
	else if(f != 1) exit(-1);
	xedtty[0] = edtty[0];
	xedtty[1] = edtty[1];
	xedtty[2] = 041 | (edtty[2] & ~073);
	stty(1,xedtty);
	if(modone) {
		blank = H1200DESTBL;
		destbl = M1DESTBL;
		wctl(M1LEADIN);
		wctl(M1TYPE1);
	}
	f = rmrplac();
	display(1);
	if(f) posn(DFLTPOSN,1);
	else posn(0,1);
	nice(-100);
	f = getuid();
	setuid(f.lo);
}

readfile()
{
	register char *l;
	register cnt, b;
	int t;

	for(linecnt = 0; (cnt = intread()); linecnt++) {
		assign(worksp, linecnt);
		l = worksp[linecnt];
		b = 0;
		while(b < cnt && (t = read(pipin,&l[b],cnt - b)) > 0) b =+ t;
		if(t <= 0) xexit();
	}
}

display(f)
{
	register lin, i, t;

	if(f) {
		wbyt(CLEAR);
		for(t = 0; t <= SCRNLEN; t++)
			for(i = 0; i <= SCRNWID; i++) screen[t][i] = destbl;
	}
	if(chkque()) return;
	for(lin = 0; lin <= SCRNLEN; lin++) {
		if(chkque()) return;
		wline(lin);
	}
}

chkque()
{
	register char c;
	int info[3];

	gtty(1,info);
	if(qcnt <= qsub && info[1] == 0) return(0);
	c = xread();
	--qsub;
	switch(c) {
		case RSHIFT:
		case LSHIFT:
		case MINUSPG:
		case MINUSLINE:
		case REPAINT:
		case MKLINE:
		case RMLINE:
		case PLUSPG:
		case PLUSLINE:
			return(1);

		default:
			return(0);
	}
}

posn(l,c)
{
	register ll, cc, tlc;

	if((tlc = l) < 0) tlc = l = 0;
	if(tlc > SCRNLEN) tlc = l = SCRNLEN;
	if(c < 0) c = 0;
	if(c > SCRNWID) c = SCRNWID;

	if((ll = line) == l && column == c) return;
	cc = column;

	if(modone) {
		wctl(M1LEADIN);
		wctl(M1POSN);
		if(c < 32) wctl(c + 96);
		else wctl(c);
		wctl(l + 96);
		line = l;
		column = c;
		return;
	}

	if(ll > tlc) wbyt(TOP);

	for(ll = line; ll < tlc; ll++) wbyt(LF);
	tlc = c;
	if(cc > tlc && (cc - tlc) > tlc) wbyt(RETURN);

	for(cc = column; cc > tlc; --cc) wbyt(BACKSP);
	for(cc = column; cc < tlc; cc++) wbyt(blank);
}

dbyt()
{
	write(1,bytbuf,bytcnt);
	bytcnt = 0;
}

writfil()
{
	register char *tl;
	register f;

	dbyt();
	for(f = 0; f < linecnt; f++) {
		tl = worksp[f];
		while(*tl) {
			if(*tl == QUOTE) if(*++tl) *tl =- 0100;
			if(*tl) putch(*tl++);
		}
		putch(LF);
		dpipe();
	}
	bytcnt = 0;
	write(pipout,&bytcnt,2);
}

getarg()
{
	register char *charg, c;
	register t;
	int oldwalwd;

	oldwalwd = walwd;
	walwd = 0;
	if(modone) wbyt(M1CURS);
	posn(0,1);
	for(charg = "Arg:"; *charg;) wbyt(*charg++);
	for(t = 5; t < SCRNWID; t++) if(screen[0][t] != destbl) {
		posn(0,t);
		wbyt(destbl);
	}
	posn(0,6);
	charg = argbuf;
	for(;;) {
		if(column >= SCRNWID) {
			bell();
			walwd = oldwalwd;
			reset();
		}
		c = xread();
		theswitch:
		switch(c) {
			case LWORD:
			case RWORD:
			case RIGHT:
			case EOL:
			case TOP:
				break;

			case BACKSP:
			case RUBOUT:
				if(charg <= argbuf) break;
				--charg;
				wbyt(BACKSP);
				wbyt(destbl);
				wbyt(BACKSP);
				break;

			case TAB:
				*charg++ = c;
				t = column % TABSIZ;
				while(t++ <= TABSIZ) wbyt(destbl);
				break;

			case '\\':
				wbyt(c);
				wbyt(BACKSP);
				c = xread();
				switch(c) {
					case '\\':
						break;
					case '(':
						c = '{';
						break;
					case ')':
						c = '}';
						break;
					case '!':
						c = '|';
						break;
					case '\'':
						c = '`';
						break;
					case '^':
						c = '~';
						break;
					default:
						wbyt('\\');
						*charg++ = '\\';
						goto theswitch;
				}
				wbyt(c);
				*charg++ = c;
				break;

			default:
				if(c < 040 || c == 0177) {
					*charg = 0;
					wline(0);
					arg++;
					walwd = oldwalwd;
					return(c);
				}
				if(c == 040) wbyt(destbl);
				else wbyt(c);
				*charg++ = c;
				break;
		}
	}
}

numrcarg(nlin)
{
	register char *f;
	register t;

	f = nlin;

	if(!arg) return(oldnarg);

	for(t = 0; *f >= '0' && *f <= '9'; f++) t = t * 10 + (*f - '0');
	if(*f) {
		bell();
		reset();
	}
	posn(savline,savcolumn);
	if(screen[line][column] != savchar) {
		wbyt(savchar);
		wbyt(BACKSP);
	}
	oldnarg = t;
	return(t);
}

restposn()
{
	posn(savline, savcolumn);
	if(screen[line][column] == savchar) return;
	wbyt(savchar);
	wbyt(BACKSP);
}

fwdsrch(wrap)
{
	register col;
	register char *wl, *c;
	int lnum;
	int strtcol, end;

	strtcol = col = workcol;
	col++;
	lnum = savline;
	end = SCRNLEN + 1;
	for(;;) {
		while(lnum < end) {
			wl = worksp[lnum];
			for(c = &wl[col]; *c; c++) if(parteq(c, sbuf)) goto found;
			col = 0;
			lnum++;
		}
		if(wrap <= 0) break;
		lnum = 0;
		end = savline;
		wrap = -1;
	}
	if(wrap) {
		wl = worksp[(lnum = savline)];
		col = 0;
		for(c = &wl[col]; col++ < strtcol; c++) if(parteq(c, sbuf)) goto found;
	}
	bell();
	restposn();;
	return;
	found:
	findposn(lnum, c);
}

bkwdsrch()
{
	register col;
	register char *wl, *c;
	int lnum;

	col = workcol;
	lnum = savline;
	wl = worksp[lnum];
	c = &wl[--col];
	for(;;) {
		for( ; col-- >= 0; --c) if(parteq(c, sbuf)) goto finish;
		if(--lnum < 0) {
			bell();
			restposn();;
			return;
		}
		wl = worksp[lnum];
		for(col = 1; *wl++; col++);
		c = wl;
	}
	finish:
	findposn(lnum, c);
}

parteq(lsec,skey)
{
	register char *l, *s;

	l = lsec;
	s = skey;

	while(*l++ == *s++ && *s);

	return(*--l == *--s);
}

findposn(l,c)
char *c;
{
	register char *wl, *cc;
	register t;

	if(sbuf == argbuf) {
		wl = argbuf;
		cc = srchbuf;
		while(*cc++ = *wl++);
	}
	cc = c;
	wl = worksp[l];

	for(t = 0; wl < cc; )
		if(*wl++ == TAB) t =+ (TABSIZ - (t % TABSIZ));
		else t++;

	t++;
	if(t < coffset || t > coffset + SCRNWID) {
		coffset = (t - (t%TABSIZ)) - TABSIZ * 5;
		if(coffset < 0) coffset = 0;
		else if(coffset > LINLEN - SCRNWID + 1) coffset = LINLEN - SCRNWID + 1;
	}
	display(0);
	posn(l, t - coffset);
}

pickbuf()
{
	if(*argbuf != 0) sbuf = argbuf;
	else {
		sbuf = srchbuf;
		if(*sbuf == 0) {
			bell();
			restposn();;
			reset();
		}
	}
}

rmline()
{
	register t, del, f;

	if(arg) if((del = numrcarg(argbuf)) <= 0) return; else;
	else del = 1;

	if(savline >= linecnt || savline + del > linecnt || del > SAVEMAX) {
		display(0);
		bell();
		return;
	}
	if(savline <= oldlnum) oldlnum = -1;
	changed++;
	save(del);
	f = del;
	for(t = savline; t < linecnt; t++) {
		if(--f >= 0) release(worksp,t);
		worksp[t] = worksp[t + del];
	}

	linecnt =- del;
	if(linecnt <= SCRNLEN && !edimode) askedit(1);
	display(0);
	posn(savline,savcolumn);
}

asgntabl(byts)
{
	register char *nfree, *wrds;

	wrds = byts * 2;
	if(corend - nextfree < wrds) {
		sbrk(wrds + 8);
		corend = sbrk(0);
	}
	nfree = nextfree;
	nextfree =+ wrds;
	return(nfree);
}

rmchar(stp)
{
	register char *count;	/* Sometimes */
	register char *lptr, *t;
	int cl;
	char ch;

	if(!walwd || worksp[line] == 0 || column == 0 || column >= SCRNWID) {
		bell();
		return;
	}
	if(line != oldlnum) copyline(worksp[oldlnum = line],0,oldline);
	if(stp) count = stp;
	else count = 1;
	changed++;

	repeat:
	if(!walwd || worksp[line][workcol] == 0) {
		bell();
		return;
	}
	cl = column;
	if(stp == -1) {
		t = &worksp[line][LINLEN+2];
		lptr = &worksp[line][workcol];
		while(lptr < t && *lptr) *lptr++ = 0;
	} else {
		t = lptr = &worksp[line][workcol];
		while(*t++);
		t =+ count;
		count =+ lptr;
		if(count > &worksp[line][LINLEN+1]) count = &worksp[line][LINLEN+1];
		while(count < t && *count) *lptr++ = *count++;
		t = &worksp[line][LINLEN + 1];
		while(lptr < t && *lptr) *lptr++ = 0;
	}
	wline(line);
	posn(line,cl);
	if(stp) return;
	wcolocat();
	count = 0;
	if(qsub == qcnt) {
		if(xread() != RMCHAR) {
			--qsub;
			return;
		} else count = 1;
	}
	while(qsub != qcnt)
		if(xread() == RMCHAR) count++;
		else {
			--qsub;
			stp++;
			break;
		}
	if(count > 0) goto repeat;
}

assign(arry,f)
char **arry;
{
	register t;
	if(freecnt) {
		arry[f] = freelist[--freecnt];
		for(t = 0; t < LINLEN+2; t++) arry[f][t] = 0;
		return;
	}
	if(corend - nextfree < LINLEN+2) {
		sbrk(LINLEN * 5);
		corend = sbrk(0);
	}
	arry[f] = nextfree;
	nextfree =+ LINLEN + 2;
}

release(arry,f)
char **arry;
{
	if(arry[f] == 0) return;
	freelist[freecnt++] = arry[f];
	arry[f] = 0;
}

mkline(f)
{
	register toadd, t, i;

	if(savline >= linecnt) return(0);
 	if(f + linecnt >= MAXLINES) askedit(1);
	if(f + linecnt >= MAXLINES) f = (MAXLINES - linecnt) - 1;
	toadd = f;
	i = savline;
	if(i <= oldlnum) oldlnum = -1;
	changed++;
	for(t = linecnt; t >= i; --t) worksp[t+toadd] = worksp[t];

	i = savline;
	t = savline+toadd;
	while(i < t) assign(worksp,i++);

	linecnt =+ toadd;
	return(1);
}


save(rmlning)
{
	int num, cnt;
	register f;
	register char *wl, *pl;
	char **whchtab;

	if(!rmlning) {
		if(!arg) if(getarg() == ARG) {
			posn(savline,savcolumn);
			return;
		}
		wl = argbuf;
		if(*wl > '9') lastsave = *wl++ - 'a';
		if(lastsave < 0 || lastsave > 9) {
			bell();
			return;
		}
		whchtab = savetabl[lastsave];
		if(whchtab == 0) whchtab = savetabl[lastsave] = asgntabl(SAVEMAX);
		num = numrcarg(wl);
		cnt = savecnt[lastsave];
	} else {
		whchtab = clostabl;
		num = rmlning;
		cnt = rmlincnt;
	}
	if(num > SAVEMAX || num <= 0 || savline + num > linecnt) {
		bell();
		return;
	}
	for(f = 0; f < cnt; f++) release(whchtab,f);
	for(f = 0; f < num; f++) assign(whchtab,f);

	for(f = 0; f < num; f++) {
		wl = worksp[savline+f];
		pl = whchtab[f];
		while(*pl++ = *wl++);
	}
	if(!rmlning) savecnt[lastsave] = num;
	else rmlincnt = num;
}

restore()
{
	register f;
	register char *wl, *pl;
	int num;
	char **whchtab;

	if(arg) f = RESTORE;
	else if((f = getarg()) == ARG) goto posnit;
	if((f == RESTORE || f == SAVE) && *argbuf != 'u') {
		if(*argbuf) f = *argbuf - 'a';
		else f = lastsave;
		if(f < 0 || f > 9) {
			bell();
			return;
		}
		whchtab = savetabl[f];
		num = savecnt[f];
	} else if(f == RMLINE || *argbuf == 'u') {
		whchtab = clostabl;
		num = rmlincnt;
	} else goto posnit;
	if(num <= 0) {
		bell();
		posn(savline,savcolumn);
		return;
	}
	if(savline >= linecnt) {
		for(f = linecnt; f < savline + num; f++) {
			release(worksp,f);
			assign(worksp,f);
		}
		linecnt = f;
	} else mkline(num);
	changed++;
	for(f = 0; f < num; f++) {
		if(worksp[savline+f] == 0) assign(worksp,savline+f);
		wl = worksp[savline+f];
		pl = whchtab[f];
		while(*wl++ = *pl++);
	}

	display(0);
	posnit:
	posn(savline,savcolumn);
}

copyline(old, col, new)
char *old, *new;
{
	register char *o, *n;
	register t;

	o = &old[col];
	n = new;
	for(t = 0; t < LINLEN+2; t++) *n++ = 0;
	n = new;
	while(*n = *o++) n++;
}

xread()
{
	register t;
	register char old;
	int info[3];
	if(qsub == qcnt) {
		qcnt = qsub = 0;
		if(worksp[line][workcol] == TAB && walwd && column &&
			column < SCRNWID && line < linecnt) {
				old = screen[line][column];
				wbyt('T');
				wbyt(BACKSP);
		} else old = 0;
		dbyt();
		read(0,&readq[qcnt],1);
		if(readq[qcnt++] == ED) goto end;
		gtty(1,info);
		while((t = info[1]) > 0 && qcnt < QSIZE) {
			while(--t >= 0 && qcnt < QSIZE)  {
				read(0,&readq[qcnt],1);
				if(readq[qcnt++] == ED) goto end;
			}
			gtty(1,info);
		}
		end:
		if(old) {
			wbyt(old);
			wbyt(BACKSP);
			dbyt();
		}
	}
	return(readq[qsub++]);
}

putch(c)
char c;
{
	bytbuf[bytcnt++] = c;
}

ed()
{
	int targ;
	register t;
	register char *l;

	if(!arg) posn(SCRNLEN,0);
	dbyt();
	if(!arg) {
		write(1,"\n",1);
		stty(1,edtty);
	}
	if(!changed) targ = -1;
	else targ = 1;
	write(pipout,&targ,2);
	if(targ == 1) writfil();
	if(linecnt && savline > linecnt - 1) targ = baseline + linecnt - 1;
	else targ = baseline + savline;
	write(pipout,&targ,2);
	if(arg) targ = -1;
	else targ = -2;
	write(pipout,&targ,2);
	t = rmrplac();
	stty(1,xedtty);
	display(!arg);
	if(arg) posn(savline,savcolumn);
	else if(t) posn(DFLTPOSN,1);
	else posn(0,1);
}

askedit(force)
{
	int tio;
	register t;

	if(!force && baseline == oldbasel) return;
	dbyt();
	if(!changed) tio = -1;
	else tio = 1;
	write(pipout,&tio,2);
	if(tio == 1) writfil();
	tio = baseline + savline;
	write(pipout,&tio,2);
	tio = baseline;
	if(tio < 0) tio = 0;
	write(pipout,&tio,2);
	rmrplac();
}

dpipe()
{
	write(pipout,&bytcnt,2);
	write(pipout,bytbuf,bytcnt);
	bytcnt = 0;
}

rmrplac()
{
	register t, f, p;

	for(t = 0; t < linecnt; t++) release(worksp,t);
	baseline = intread();
	p = intread();
	if(p == 1) edimode = 1;
	else edimode = 0;
	readfile();
	if(baseline == 0) baseline = 1;
	oldlnum = -1;
	changed = 0;
	oldbasel = baseline;
	return(p >= 3);
}

bell()
{
	dbyt();
	write(1,"\7\7\7\7",2);
}

xexit()
{
	stty(1,edtty);
	exit();
}

intread()	/* Because we can't trust reads on pipes */
{
	struct { char lo; char hi; };
	int intg;
	char byt; 

	if(read(pipin,&byt,1) <= 0) xexit();
	intg.lo = byt;
	if(read(pipin,&byt,1) <= 0) xexit();
	intg.hi = byt;
	return(intg);
}
