#
/*
 *	FS Version 5.1 - Compile i & d space seperated
 *	Mark Pearson  -  IIASA 1976, March 1977.
 */
#define OFF	0
#define ON	1
#define EMPTY	2

#define IMASK	060000
#define IDIR	040000
#define IFILE	000000
#define MAGIC	0123456
#define CPLEN	4096
#define DIRLEN	sizeof(pdir)

#define WTM 0
#define FSF 1
#define BSF 2
#define FSR 3
#define BSR 4
#define REW 5
#define OFL 6

#define ENOENT	2
#define ENXIO	6
#define EEXIST	17

#define OLDTDATE0 05456	/* To accommodate old FS Tapes */
#define OLDTDATE1 0120157

#define PEX 0
#define PER 1
#define PFX 2
#define PFR 3

#define BANG	-1

#define SAVE	1
#define RESTORE	2
#define LIST	3
#define STOP	4
#define UNIX	5
#define REWIND	6
#define PRESER	7
#define EXTRACT	8
#define CHDIR	9
#define SET	10
#define OFFLIN	11

char *comtab[] {
	"save",
	"restore",
	"list",
	"stop",
	"unix",
	"rewind",
	"preserve",
	"extract",
	"chdir",
	"setdate",
	"offline",
	0
};

#define EROFF	0
#define ERNORNG	1
#define ERPRTY	2
#define ERBAD	3
#define EREOT	4
#define ERLEN	5
#define ERUGH	6

char *tperrtab[] {
	"%s: off line\n",
	"%s: no write ring\n",
	"%s: parity err\n",
	"%s: hard err\n",
	"%s: EOT\n",
	badfmt,
	"%s: get help\n"
};

char	**argp;
char	*argpp[32];
char	*corend;
char	*cpbuf;
char	*dbuf;
char	*dirname;
char	*exstring;
char	*labelname	" Label/directory: ";
char	tapename[]	"/dev/rmt?";
char	*timename;
char	*argl;
char	cantwrt[]	"Tape bad? No writing\n";
char	lastc;
char	mtchmesg[]	"No match\n";
char	notdir[]	"%s: not directory file\n";
char	nothere[]	"%s not on tape\n";
char	peekc;
char	shname[]	"/bin/sh";
char	*subdat;
char	synmesg[]	"Syntax\n";
char	tagain[]	"Try again\n";
char	badfmt[]	"Tape format err\n"; /* FS format damaged, serious */
char	*labl;
extern	errno;
extern	fout;
extern	ldivr;
int	added;
int	argc;
int	ateot;
int	based;
int	basedtime[2];
int	dir;
int	dirdat[2];
int	dirinum[2];
int	dotminmaj;
int	dsw;
int	fground;
int	filecnt;
int	freshstart	1;
int	impendrew;
int	labeled;
int	mastime[2];
int	mkdir;
int	needir	1;
int	nomorwrt;
int	nomount;
int	noring;
int	oldtdate[2];	/* Old Tapes */
int	orig;
int	procno;
int	reset();
int	sflag;
int	sig2;
int	sig3;
int	sigallwd;
int	sizelimit;
int	skipobjs;
int	subing;
int	subtab[16][2];
int	tape;
int	wotape	1;
int	tapeposn;
int	tpshcth();
int	update	1;
int	verbose;

struct	{
	int  minmaj;
	int  inumber;
	int  flags;
	char links;
	char uid;
	char gid;
	char size0;
	int  size1;
	int  addr[8];
	int  actime[2];
	int  modtime[2];
	} stats;

struct	nmstr {
	int c_mrecnt;
	char c_name[];
	};

struct ldirstr	{
	int	d_magic;
	int	d_no;
	char	d_name[58];
	char	d_ids[2];
	int	d_sdate[2];
	int	d_vers;
	int	d_mdate[2];
	int	d_flags;
	int	d_size[2];
	};

struct cdirstr	{
	int	c_magic;
	int	c_no;
	char	c_ids[2];
	int	c_sdate[2];
	int	c_vers;
	int	c_mdate[2];
	int	c_flags;
	int	c_size[2];
	struct	nmstr *c_nmloc;
	char	*c_next;
	};

struct	ldirstr pdir;
struct  cdirstr *gdir;
struct  cdirstr *dbufptr;

main(argcc,argv)						/* main */
char **argv;
{
	register t, command;
	int waitstat;
	char cppbuf[CPLEN], argll[160], subdt[58], labll[30];

	cpbuf = cppbuf;
	argl = argll;
	subdat = subdt;
	labl = labll;

	fstart(argcc,argv);
	setexit();
	buffer(EMPTY);

	for(;;) {
		buffer(OFF);
		if(procno && fground)
			while((t = wait(&waitstat)) != procno && t != -1);
		procno = 0;
		fground = 1;
		signal(2,sig2);
		signal(3,sig3);
		verbose = dsw = skipobjs = nomount = 0;
		sizelimit = subing = mkdir = sflag = 0;
		update = 1;
		write(1,"= ",2);
		if((argc = getline()) == 0) continue;
		command = getcmd();
		chkargs();
		time(mastime);
		if(impendrew) rew();
		impendrew = 0;
		switch(command) {

			case SAVE:
				if(argc < 2 || wotape) break;
				if(nomorwrt) error(PFR, cantwrt);
				if(noring) error(PFR, tperrtab[ERNORNG], tapename);
				if(argc == 2) argp[2] = argp[1];
				if(stat(argp[1], &stats) < 0)
					error(PER, argp[1]);
				save(OFF, argp[1], argp[2]);
				dumpdir();
				break;

			case PRESER:
				if(wotape) break;
				if(nomorwrt) error(PFR, cantwrt);
				if(noring) error(PFR, tperrtab[ERNORNG], tapename);
				if(sflag) setsub();
				preserve();
				break;

			case RESTORE:
				if(argc < 2 || wotape) break;
				if(argc == 2) argp[2] = argp[1];
				locate(argp[1]);
				restore(OFF,argp[1],argp[2]);
				break;

			case EXTRACT:
				if(wotape) break;
				if(sflag) setsub();
				extract();
				break;

			case LIST:
				if(needir) tpsearch(0,0);
				if(sflag) unixout("sort +0.4 -0.36");
				if(fout == 1) buffer(ON);
				list();
				break;

			default:
				write(2,"Invalid command\n",16);
				break;

			case STOP:
				if(!wotape) {
					if(needir) unlink(dirname);
					else dumpdir();
				}
				exit();

			case REWIND:
				rew();
				break;

			case OFFLIN:
				dostty(OFL, 0);
				break;

			case CHDIR:
				if(chdir(argp[1])!=0) perror("chdir");
				break;

			case BANG:
			case UNIX:
				signal(2,1);
				signal(3,1);
				if(procno = fork()) {
					if(procno == -1) error(PFR, tagain);
				} else {
					if(command == UNIX) execl(shname, "sh",0);
					else execl(shname, "sh", "-c", &argp[0][1], 0);
					exit();
				}
				break;

			case SET:
				setdate();
				break;

		}
	}
}

fstart(argcc,argv)						/* fstart */
char **argv;
{
	register goodir, len, fildes;
	int goodtape, i, brksiz;
	struct ldirstr tdir;

	time(mastime);
	argv++;
	if(**argv == '-') (*argv)++;
	tapename[8] = **argv;
	argv++;
	--argcc;
	while(--argcc > 0) {
		if(eq(*argv,"-d")) {
			dirname = argv[1];
			argv++;
			--argcc;
		}  else  if(eq(*argv,"-b")) {
				timename = argv[1];
				argv++;
				--argcc;
				if((fildes = open(timename,2)) < 0) error(PEX,timename);
				read(fildes,basedtime,4);
				close (fildes);
				based++;
		}  else  dirname = *argv;
		argv++;
	}

	for(i = 3; i < 15; i++) close(i);
	goodtape = 0;
	if(tapename[8] == 'n') goto ntp;
	wotape = 0;
	if((tape = open(tapename,2)) < 0) {
		if(errno == ENXIO) error(PFX, "%s: in use\n", tapename);
		error(PEX, tapename);
	}
	rew();
	if((len = read(tape, &pdir, DIRLEN)) != 0){
		if(len < 0) {
			if((i = tpstat(0)) == ERLEN) goto notfs;
			error(PFX, tperrtab[i], tapename);
		}
		tpstat(1);
		if(len != DIRLEN || pdir.d_magic != MAGIC) {
			notfs:
			write(1,"Not FS tape. Overwrite? ",24);
			if(!yes()) {
				seek(0, 0, 2);
				exit();
			}
			rew();
			wtm(2);
			rew();
		} else {
			goodtape = 1;
			if(keywd(labelname, pdir.d_name)) {
				labeled = 1;
				cp(pdir.d_name+18, labl);
				if(!dirname) dirname = labl;
			}
		}
	}
	ntp:
	oldtdate[0] = OLDTDATE0;	/* Old Tapes */
	oldtdate[1] = OLDTDATE1;
	if(!wotape && !goodtape && !dirname) {
		printf("Tape empty\n");
		askdname();
	}
	if(!dirname) dirname = "fs.dir";

	goodir = 0;
	if(stat(dirname,&stats) >= 0) {
		if((dir = open(dirname, 2)) >= 0) {
			if((len = read(dir, &tdir, DIRLEN)) == DIRLEN) {
				if(tdir.c_magic == MAGIC) {
					goodir = 1;
				} else error(PFX, notdir, dirname);
			} else	if(len > 0) {
					error(PFX, notdir, dirname);
				} else if(len < 0) error(PEX, dirname);
		} else error(PEX, dirname);
	} else {
		if(wotape) error(PEX, dirname);
		dir = creat(dirname, 0666);
	}
	close(dir);
	if((dir = open(dirname,2)) < 0) error(PEX, dirname);

	if(wotape) goto finish;
	if(goodtape && goodir) {
		if((dpcmp(tdir.d_sdate,pdir.d_sdate) == 0 &&
			dpcmp(tdir.d_mdate,pdir.d_mdate) == 0))
				goto finish;
		stat(dirname, &stats);
		if(stats.size0 == 0 && stats.size1 == 0) {
			goodir = 0;
			goto fini2;
		}
		wrongdir:
		printf("Wrong directory. Overwrite? ");
		if(!yes()) {
			seek(0, 0, 2);
			exit();
		}
		goodir = 0;
		close(dir);
		close(creat(dirname, 0666));
		dir = open(dirname,2);
		goto finish;
	}
	if(!goodtape && goodir) goto wrongdir;
	finish:
	stat(dirname, &stats);
	fini2:
	dirdat[0] = stats.modtime[0];
	dirdat[1] = stats.modtime[1];
	dirinum[0] = stats.inumber;
	dirinum[1] = stats.minmaj;
	dbuf = dbufptr = gdir = sbrk(0);
	if(!goodir || (brksiz = ldiv(stats.size0, stats.size1, 512 * 2)) < 2)
		brksiz = 2;
	while(brksiz > 64) {
		brksiz =- 64;
		sbrk(64 * 512);
	}
	sbrk(brksiz * 512);
	corend = sbrk(0);
	if(goodir) count();
	rew();
	orig = filecnt;
	if(!goodtape && !wotape) label();
	if((sig2 = signal(2,reset)) != 0) signal(2,sig2);
	else {
		sig2 = reset;
		sigallwd++;
	}
	if((sig3 = signal(3,0)) != 0) signal(3,sig3);
	signal(13, 1);
	freshstart = 0;
	fout = 1;
}

count()                                                         /* count */
{
	register len;

	seek(dir,0,0);
	filecnt = gdir = 0;

	while((len = read(dir,&pdir,DIRLEN)) > 0) {
		if(pdir.d_magic != MAGIC) goto eout;
		chkcore();
		putdir();
	}
	if(len < 0) error(PEX,dirname);
	if(len > 0) {
		eout:
		error(PFX, "Bad directory\n");
	}
	printf("%d files\n",filecnt);
	needir = 0;
}

getline()							/* getline */
{
	register char *line, **ptr, *oline;
	int i, oneout;

	line = argl;
	argp = argpp;
	for(i = 0; i < 32; ) argp[i++] = 0;
	ptr = &argp[0];
	oline = line;
	oneout = 0;
	for(i = 0; line = getwrd(line); ) {
		if(*oline == '^' || *oline == '|') {
			if(oneout) error(PFR, synmesg);
			unixout(oline+1);
			line = oline;
			continue;
		}
		if(*oline == '>') {
			oneout++;
			redir(oline+1);
			line = oline;
			continue;
		}
		*ptr++ = oline;
		oline = line;
		i++;
	}
	return(i);
}

getwrd(l)							/* getwrd */
char *l;
{
	register char *p, *last;

	p = l;
	while((peekc = getch()) == ' ') peekc = 0;
	nchar:
	switch(peekc = getch()) {

		case '\n':
			if(l == p) return(peekc = 0);
			*p++ = 0;
			return(p);

		case '^':
		case '|':
			if(l == p) {
				if(l == argl) error(PFR, synmesg);
				while((*p = getch()) != '\n') {
					if(*p != ' ') last = p;
					p++;
				}
				if(*last == '&') {
					*last = ' ';
					fground = 0;
				}
				*p++ = 0;
				peekc = '\n';
				return(p);
			}
			*p++ = 0;
			return(p);

		case '!':
			if(p != l || l != argl) goto def;
			*p++ = '!';
			peekc = 0;
			while((*p = getch()) != '\n') p++;
			*p++ = 0;
			peekc = '\n';
			return(p);

		case '>':
			if(l == p) {
				if(l == argl) error(PFR, synmesg);
				*p++ = '>';
				peekc = 0;
				if((peekc = getch()) == '>') {
					*p++ = '>';
					peekc = 0;
				}
				while((peekc = getch()) == ' ') peekc = 0;
				goto nchar;
			}
		case ' ':
			*p++ = 0;
			return(p);

		def:
		default:
			*p++ = peekc;
			peekc = 0;
			goto nchar;
	}
}

getch()								/* getch */
{
	char c;

	if(lastc = peekc) {
		peekc = 0;
		return(lastc);
	}
	if(read(0, &c ,1) <= 0) exit();
	if(c == '\\') {
		if(read(0, &c ,1) <= 0) exit();
		if(c == '\n') c = ' ';
	}
	return(lastc = c);
}

getcmd()							/* getcmd */
{
	char **c;

	c = comtab;
	while(*c) if(keywd(argp[0], *c++)) return(c - comtab);
	if(argp[0][0] == '!') return(BANG);
	return(0);
}

keywd(ar, cm)							/* keywd */
{
	register char *a, *c;

	a = ar;
	c = cm;

	while(*a++ == *c && *c++);

	return(!*--a);
}

chkargs()							/* chkargs */
{
	register char c, dash, *p;

	while(argc > 1 && ((dash = argp[1][0]) == '-' || dash == '+')) {
		p = &argp[1][1];
		while(c = *p++) switch(c) {
			case 'a':
				dsw++;
				break;
			case 'o':
				skipobjs++;
				break;
			case 'u':
				update = 0;
				break;
			case 'm':
				nomount++;
				break;
			case 'l':
				update = 0;
				break;
			case 'd':
				mkdir++;
				break;
			case 's':
				sflag++;
				break;
			case '+':
			case '-':
				p = getsize(c, p);
				break;
			case 't':
			case 'v':
				verbose = 03;
				break;
			case 'c':
				verbose = 01;
				break;
			case 'n':
				verbose = 02;
				break;
			default:
				if(c >= '0' && c <= '9') {
					p = getsize(dash, p-1);
					break;
				}
				error(PFR, "Switch?\n");
		}
		argp++;
		--argc;
	}
}

list()								/* list */
{
	register char *pattern;
	register size, t;
	int i, nulint[2], mcnt;
	char tba[16];
	char tbb[16];

	if(filecnt == 0) return;
	tba[0] = tbb[0] = nulint[0] = nulint[1] = 0;
	i = 1;
	if(!verbose && argc == 1)
		printf(" No.   Name                          Vers  Size  Date Saved       Last Modified\n");
	do {
		mcnt = 0;
		gdir = dbuf;
		pattern = argp[i++];
		for(t= -1; ++t < filecnt; gdir = gdir->c_next) {
			if(pattern && !match((gdir->c_nmloc)->c_name,pattern)) continue;
			mcnt++;
			if(update && (gdir->c_nmloc)->c_mrecnt != gdir->c_no) continue;
			if(!verbose){
				size=ldiv(gdir->c_size[0],gdir->c_size[1],512);
				if(ldivr)size++;
				if(dpcmp(gdir->c_sdate,oldtdate)<0 || dpcmp(gdir->c_sdate,mastime)>0)	/* Old Tapes */
					tba[0]=0;
				else fixtime(ctime(gdir->c_sdate),tba);
				if(!t && labeled)
					fixtime(ctime(dirdat),tbb);
				else fixtime(ctime(gdir->c_mdate),tbb);
				printf("%4d %-32.32s %3d %4d  %15.15s  %s\n",
					t,(gdir->c_nmloc)->c_name,gdir->c_vers,size,tba,tbb);
			} else printf("%4d %s(%d)\n",t,(gdir->c_nmloc)->c_name,gdir->c_vers);
		}
		if(mcnt == 0) printf(mtchmesg);
	} while(i < argc);
}

fixtime(cline,tline)						/* fixtime */
char *cline, *tline;
{
	register char *tc, *tl;
	tl=tline;
	tc = cline + 22;
	*tl++ = *tc++;
	*tl++ = *tc;
	*tl++ = ' ';
	tc = cline + 4;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc++;
	*tl++ = *tc;
	*tl = 0;
	return(tline);
}

save(up,tosave,saveas)						/* save */
char *tosave, *saveas;
{
	int tt, sign;
	register fildes, t, size;

	if(stats.inumber == dirinum[0] && stats.minmaj == dirinum[1]) {
		if(verbose&02) printf("%s: FS directory\n",tosave);
		return;
	}
	if((stats.flags&IMASK)==IDIR) {
		if(verbose&02) printf("%s: directory\n",tosave);
		return;
	}
	if((stats.flags&IMASK)!=IFILE) {
		if(verbose&02) printf("%s: not a file\n",tosave);
		return;
	}
	if(based && dpcmp(basedtime,stats.modtime) > 0) goto nsave;
	if(sizelimit) {
		if(sizelimit > 0) sign = 1;
		else sign = -1;
		size = ldiv(stats.size0,stats.size1,512);
		if(ldivr) size++;
		size =* sign;
		if(size > sizelimit) {
			if(verbose&02) printf("%s: size\n",tosave);
			return;
		}
	}
	collect:
	pdir.d_vers = getvers(saveas);
	if(up && pdir.d_vers > 1 && dpcmp(gdir->c_mdate,stats.modtime) >= 0) {
		nsave:
		if(verbose&02) printf("Not updated: %s\n",saveas);
		return;
	}
	if((fildes=open(tosave,0))<0) {
		perror(tosave);
		return;
	}
	if(read(fildes,&tt,2) == 0) {
		if(verbose&02) printf("%s: zero length\n",tosave);
		close(fildes);
		return;
	}
	seek(fildes,0,0);
	if(skipobjs) {
		if(tt == 0407 || tt == 0410 || tt == 0411 || tt == 01) {
			if(verbose&02) printf("%s: object\n",tosave);
			close(fildes);
			return;
		}
	}
	chkcore();
	if(dsw && !dswask(tosave)) {
		close(fildes);
		return;
	}
	cp(saveas,pdir.d_name);
	pdir.d_magic=MAGIC;
	pdir.d_no=filecnt;
	pdir.d_ids[0] = stats.uid;
	pdir.d_ids[1] = stats.gid;
	pdir.d_mdate[0]=stats.modtime[0];
	pdir.d_mdate[1]=stats.modtime[1];
	pdir.d_flags=stats.flags;
	pdir.d_size[0]=stats.size0;
	pdir.d_size[1]=stats.size1;
	pdir.d_sdate[0]=mastime[0];
	pdir.d_sdate[1]=mastime[1];
	posn(pdir.d_no);
	if(!ateot) {
		if((t = read(tape, cpbuf, CPLEN)) < 0) taperr(0);
		bsr(1);
		if(t > 0) {
			if((*cpbuf).d_magic != MAGIC) error(PFR, badfmt);
			tapeposn = (*cpbuf).d_no;
			tpsearch(0, 0);
			close(fildes);
			goto collect;
		}
	}
	if(write(tape, &pdir, DIRLEN) < DIRLEN) taperr(03);
	dsc2tp(fildes,tosave);
	putdir();
	added++;
	if(verbose&01) {
		printf("Saved: ");
		if(tosave == saveas) printf("%s(%d)\n",tosave,pdir.d_vers);
		else printf("%-32.32s as %s(%d)\n",tosave,saveas,pdir.d_vers);
	}
}

restore(up,restor,restas)					/* restor */
char *restor, *restas;
{
	register fildes, size, sign;
	int *ugid, l, fsferr;

	fsferr = 0;
	if(gdir->c_no == 0 && labeled) return;
	if(sizelimit) {
		if(sizelimit > 0) sign = 1;
		else sign = -1;
		size = ldiv(gdir->c_size[0],gdir->c_size[1],512);
		if(ldivr) size++;
		size =* sign;
		if(size > sizelimit) {
			if(verbose&02) printf("%s: size\n",restor);
			return;
		}
	}
	if(based && dpcmp(basedtime,gdir->c_mdate) > 0) goto nosave;
	if(up && stat(restas,&stats) >= 0)
		if(up && dpcmp(gdir->c_mdate,stats.modtime) <= 0) {
			nosave:
			if(verbose&02) printf("Not extracted: %s\n",restas);
			return;
		}
	if(dsw && !dswask(restor,gdir->c_vers)) return;
	again:
	posn(gdir->c_no);
	if((l = read(tape, &pdir, DIRLEN)) < 0) taperr(0);
	if(l == DIRLEN) {
		if(gdir->c_no != pdir.d_no ||
				dpcmp(gdir->c_sdate, pdir.d_sdate)) {
			if(fsferr++ > 4) {
				lerr:
				rew();
				error(PFR, badfmt);
			}
			tapeposn = pdir.d_no;
			bsr(1);
			bsf(2);
			goto again;
		}
	} else goto lerr;
	if((fildes = creat(restas, gdir->c_flags)) < 0) {
		if(errno == ENOENT && mkdir &&
			(fildes = makedir(restas)) >= 0) goto cont;
		bsr(1);
		perror(restas);
		return;
	}
	cont:
	if(dpcmp(gdir->c_sdate,oldtdate) > 0 && dpcmp(gdir->c_sdate,mastime) <= 0) { /* Old tapes */
		ugid = gdir->c_ids;
		chown(restas, *ugid);
	}
	tp2dsc(fildes,restas);
	mdate(restas,gdir->c_mdate);
	if(verbose&01) {
		printf("Restored: %s(%d)",(gdir->c_nmloc)->c_name,gdir->c_vers);;
		if(restor != restas) printf(" as %s",restas);
		printf("\n");
	}
	return;
}

makedir(filen)							/* makedir */
char *filen;
{
	register char *nptr, *dptr, *pptr;
	int *idptr;
	char *ddot, *nptr2;
	int t;

	if(getuid()) error(PFR,"Not super-user\n");
	nptr = nptr2 = filen;
	dptr = cpbuf;
	pptr = cpbuf + 200;
	ddot = cpbuf + 400;
	*pptr++ = '.';
	while((*ddot++ = *dptr = *nptr++) != '/' && *dptr) { dptr++; nptr; }
	while(*dptr) {
		*pptr = *dptr = 0;
		if((t = mknod(cpbuf, 040777, 0)) < 0 && errno != EEXIST) error(PER,"mknod");
		if(t >= 0) {
			*ddot++ = '.'; *ddot = 0;
			if(link(cpbuf, cpbuf + 400)) error(PER, cpbuf + 400);
			*ddot++ = '.'; *ddot = 0;
			if(link(cpbuf + 200, cpbuf + 400)) error(PER, cpbuf + 400);
			--ddot; --ddot;
		}
		idptr = gdir->c_ids;
		chown(cpbuf, *idptr);
		*pptr++ = *dptr++ = '/';
		while((*pptr = *nptr2++) != '/' && *pptr) pptr++;
		while((*ddot++ = *dptr = *nptr++) != '/' && *dptr) dptr++;
	}
	return(creat(filen, gdir->c_flags));
}

dsc2tp(in, name)						/* dsc2tp */
{
	register len, i;

	signal(2,1);
	while((len = read(in, cpbuf, CPLEN)) > 0) {
		if(len != CPLEN) {
			if(len < 32) {
				for(i = len; i < 32; i++) cpbuf[i] = 0;
				len = 32;
			} else if(len&1) cpbuf[len++] = 0;
		}
		if(write(tape, cpbuf, len) != len) taperr(01);
	}
	close(in);
	if(len < 0) error(PER, name);
	weot();
	signal(2,sig2);
}

tp2dsc(out,name)						/* tp2dsc */
{
	register len;
	int tot[2];
	signal(2,1);
	tot[0] = tot[1] = 0;
	while((len = read(tape, cpbuf, CPLEN)) > 0){
		if(len != CPLEN)
			if(len != 32)
				if(gdir->c_size[1]&1) --len;
				else;
			else if((len = gdir->c_size[1]&31) == 0) len = 32;
		if(write(out, cpbuf, len) != len){
			close(out);
			error(PER, name);
		}
		dpadd(tot,len);
	}
	close(out);
	if(len < 0) taperr(0);
	tapeposn++;
	if(dpcmp(tot,gdir->c_size)<0)
		error(PFR,"Bad byte count\n");
	signal(2,sig2);
}

locate(nam)							/* locate */
{
	register char *n;
	register i;
	register struct cdirstr *cd;
	char *t;
	int versno;

	n=nam;
	versno=0;
	while(*n != '(' && *n++);
	if(*--n) {
		*++n = 0;
		t = ++n;
		while(*n != ')' && *n) {
			versno =* 10;
			versno =+ *n++ - '0';
		}
		if(!*n) error(PFR, synmesg);
	}
	n=nam;
	cd = dbuf;
	if(needir && !versno) tpsearch(0,0);
	for(i=filecnt;i;--i) {
		if(eq((cd->c_nmloc)->c_name,n))
			if(!versno) {
				i=(cd->c_nmloc)->c_mrecnt;
				while(cd->c_no != i) cd = cd->c_next;
				return(gdir = cd);
			} else if(cd->c_vers == versno) return(gdir = cd);
		cd = cd->c_next;
	}
	if(needir) tpsearch(nam,versno);
	else error(PFR, nothere, n);
}

taperr(n)							/* taperr */
{
	register w, s, e;
	int vec[3];

	w = n&01;
	s = n&02;
	e = tpstat(w);

	if(e == EROFF || e == ERNORNG) {
		if(s || !w) goto out;
		else nomorwrt++;
	}
	if(e == EREOT || e == ERLEN || e == ERUGH) nomorwrt++;
	if((e == ERPRTY || e == ERBAD) && w) nomorwrt++;
	impendrew++;
	out:
	if(e == ERUGH) {
		buffer(OFF);
		gtty(tape, vec);
		printf("%o %o %o\n", vec[0], vec[1], vec[2]);
	}
	error(PFR, tperrtab[e], tapename);
}

tpstat(w)							/* tpstat */
{
	register x;
	int vec[3];

	gtty(tape,vec);
	x = vec[0];
	noring = x & 04;
	if((x &   0100) == 0) return(EROFF);	/* select remote */
	if(w && x&04)  return(ERNORNG);		/* write lock */
	if(x  & 030000)  return(ERPRTY);	/* parity err */
	if(x  &   0400)  return(ERBAD);		/* bad tape err */
	if(x  &  02000)  return(EREOT);		/* end of tape */
	if(x  &  01000)  return(ERLEN);		/* record len. err */
	if((x & 033500) == 0100) return(ERUGH); /* catch all */
	return(-1);
}

error(n,arg1,arg2,arg3,arg4)					/* error */
{
	register i;

	buffer(EMPTY);
	if(!freshstart && lastc != '\n')
		while((peekc = getch()) != '\n') peekc = 0;
	procno = 0;
	peekc = 0;
	noring = 0;
	if(n==PEX || n==PER) {
		perror(arg1);
		seek(0,0,2);
		if(n==PEX || freshstart) exit();
		for(i = 5; i < 15; i++) close(i);
		reset();
	}
	printf(arg1,arg2,arg3,arg4);
	seek(0,0,2);
	if(n==PFX || freshstart) exit();
	for(i = 5; i < 15; i++) close(i);
	reset();
}

getvers(nam)							/* getvers */
char *nam;
{
	register i;
	register struct cdirstr *cd;

	cd = dbuf;
	for(i=filecnt;i && !eq((cd->c_nmloc)->c_name,nam);--i) cd = cd->c_next;
	if(!i) {
		gdir = 0;
		return(1);
	}

	i = (cd->c_nmloc)->c_mrecnt;

	while(cd->c_no != i) cd = cd->c_next;
	gdir = cd;
	return(cd->c_vers + 1);
}

tpsearch(nm,ver)						/* tpsearch */
{
	register len;
	register struct cdirstr *gd;

	gdir = 0;
	if(sigallwd) signal(2,tpshcth);
	if(!ver) printf("Directory update - ");
	posn(filecnt);
	while((len = read(tape, &pdir, DIRLEN)) > 0) {
		if(len != DIRLEN || pdir.d_no != filecnt) {
			nomorwrt++;
			rew();
			error(PFR, badfmt);
		}
		gd = dbufptr;
		chkcore();
		putdir();
		if(ver && eq(nm,pdir.d_name) && pdir.d_vers == ver) {
			bsr(1);
			gdir = gd;
			signal(2,sig2);
			return;
		}
		fsf(1);
	}
	if(len < 0) taperr(0);
	tapeposn++;
	needir = 0;
	printf("%d files\n",filecnt);
	if(ver) error(PFR, nothere, nm);
	dumpdir();
	signal(2,sig2);
}

tpshcth()							/* tpshcth */
{
	rew();
	ateot = 0;
	filecnt = 0;
	reset();
}

chkcore()							/* chkcore */
{
	register t;
	register char *p;

	p = dbufptr;
	p =+ 80;
	if(p > corend) {
		if(((t = sbrk(1024)) == -1) && ((t = sbrk(64)) == -1)) {
			needir = 0;
			dumpdir();
			error(PFR,"Out of memory, file max\n");
		}
		corend = sbrk(0);
	}
}

putdir()							/* putdir */
{
	register int *w, *p, t;

	w = &dbufptr->c_magic;
	p = &pdir;
	*w++ = *p++;	/* copy magic */
	*w = *p;	/* copy file number */
	w = dbufptr->c_ids;
	p = pdir.d_ids;
	for(t = 0; t++ < 9;) *w++ = *p++;
	getname();
	filecnt++;
}

cp(a,b)								/* cp */
{
	register char *aa, *bb;
	aa=a;
	bb=b;
	while(*bb++ = *aa++);
}

posn(file)							/* posn */
{
	if(file == tapeposn) return;
	if(file == 0) {
		rew();
		return;
	}
	if(file > tapeposn) fsf(file-tapeposn);
	if(file<<1 > tapeposn)
		bsf(tapeposn-file);
	else {
		rew();
		fsf(file);
	}
}

rew()								/* rew */
{
	dostty(REW,1);
	tapeposn=0;
}

fsf(n)								/* fsf */
{
	dostty(FSF,n);
	tapeposn =+ n;
}

bsf(n)								/* bsf */
{
	if(tapeposn < n) n = tapeposn;
	dostty(BSF,n+1);
	dostty(FSR,1);
	tapeposn =- n;
}

wtm(n)								/* wtm */
{
	dostty(WTM,n);
	tapeposn =+ n;
}

weot()								/* weot */
{
	dostty(WTM,2);
	dostty(BSF,1);
	tapeposn++;
	ateot++;
}

bsr(n)								/* bsr */
{
	dostty(BSR,n);
}

dostty(fn,n)							/* dostty */
{
	int arg[3];

	if(wotape) return;
	arg[0] = fn;
	arg[1] = n;
	if(stty(tape, arg) < 0) {
		if(freshstart)
			error(PFX, tperrtab[taperr(fn == WTM)], tapename);
		taperr(fn == WTM);
	}
	ateot = 0;
}

eq(ar,cm)							/* eq */
{
	register char *a, *c;

	a = ar;
	c = cm;

	while(*a++ == *c && *c++);

	return((c != cm) && (!*--a && !*--c));
}

buffer(n)							/* buffer */
{
	if(n == ON) fout=dup(1);
	else {
		if(fout <= 1) goto set;
		if(n == OFF) {
			flush();
			close(fout);
		} else {
			close(fout);
			flush();
		}
		set:
		fout=1;
	}
	flush();
}

setdate()							/* setdate */
{
	register file;
	register char *tname;

	if(argc > 1) tname = argp[1];
	else tname = timename;
	if(tname == 0) error(PFR,"File name?\n");
	if((file = creat(tname,0666)) < 0) error(PER,tname);
	time(basedtime);
	write(file,basedtime,4);
	close(file);
}

match(s, p)							/* match */
char *s, *p;
{
	if (*s=='.' && *p!='.')
		return(0);
	return(amatch(s, p));
}

amatch(as, ap)							/* amatch */
char *as, *ap;
{
	register char *s, *p;
	register scc;
	int c, cc, ok, lc;

	s = as;
	p = ap;
	if (scc = *s++)
		if ((scc =& 0177) == 0)
			scc = 0200;
	switch (c = *p++) {

	case '[':
		ok = 0;
		lc = 077777;
		while (cc = *p++) {
			if (cc==']') {
				if (ok)
					return(amatch(s, p));
				else
					return(0);
			} else if (cc=='-') {
				if (lc<=scc && scc<=(c = *p++))
					ok++;
			} else
				if (scc == (lc=cc))
					ok++;
		}
		return(0);

	default:
		if (c!=scc)
			return(0);

	case '?':
		if (scc)
			return(amatch(s, p));
		return(0);

	case '*':
		return(umatch(--s, p));

	case '\0':
		return(!scc);
	}
}

umatch(s, p)							/* umatch */
char *s, *p;
{
	if(*p==0)
		return(1);
	while(*s)
		if (amatch(s++,p))
			return(1);
	return(0);
}

label()								/* label */
{

	gdir = needir = 0;
	labeled++;
	cp(labelname, pdir.d_name);
	cp(dirname, pdir.d_name+18);
	pdir.d_no = pdir.d_size[0] = pdir.d_size[1] = 0;
	pdir.d_vers = 1;
	pdir.d_magic = MAGIC;
	pdir.d_sdate[0] = mastime[0];
	pdir.d_sdate[1] = mastime[1];
	dirdat[0] = mastime[0];
	dirdat[1] = mastime[1];
	if(write(tape, &pdir, DIRLEN) != DIRLEN)
		error(PFX, tperrtab[tpstat(1)], tapename);
	weot();
	chkcore();
	putdir();
}

askdname()							/* askdname */
{
	if(argc <= 1) {
		printf("Enter label/directory name. Suggested format: fs.NAME\n");
		while((argc = getline()) == 0);
		if(keywd(argp[0],"stop")) exit();
	}
	else argp[0] = argp[1];
	cp(argp[0], labl);
	dirname = labl;
}

getname()							/*getname */
{
	register int t;
	register char *n, *o;

	if(gdir || ((dbufptr->c_vers > 1) && findup(pdir.d_name))) {
		dbufptr->c_nmloc = gdir->c_nmloc;
		(dbufptr->c_nmloc)->c_mrecnt = dbufptr->c_no;
		dbufptr = dbufptr->c_next = dbufptr + 1;
		gdir = 0;
		return;
	}

	dbufptr->c_nmloc = dbufptr + 1;
	n = (dbufptr->c_nmloc)->c_name;
	o = pdir.d_name;
	while(*n++ = *o++);
	(dbufptr->c_nmloc)->c_mrecnt = dbufptr->c_no;
	dbufptr = dbufptr->c_next = n + (n&1);
}

dumpdir()							/* dumpdir */
{
	register int *p, *l, t;
	int i;
	char *pp, *ll;

	if(wotape) return;
	gdir = dbuf;
	for(t=0;t < orig;t++) gdir = gdir->c_next;
	for(i=orig;i < filecnt;i++) {
		p = &gdir->c_magic;
		l = &pdir;

		*l++ = *p++;
		*l = *p;

		p = gdir->c_ids;
		l = pdir.d_ids;
		for(t=0;t++ < 9;) *l++ = *p++;

		pp = (gdir->c_nmloc)->c_name;
		ll = pdir.d_name;
		while(*ll++ = *pp++);

		gdir = gdir->c_next;
		if(write(dir,&pdir,DIRLEN) < DIRLEN) error(PER,dirname);
	}
	orig = filecnt;
	gdir = 0;
}
extract()							/* extract */
{
	register int t, f, mth;
	int all;
	char *new, newpath[58];

	mth = 0;
	if(argc == 1) all = 1;
	else all = 0;
	if(needir) tpsearch(0,0);
	gdir = dbuf;
	for(f=0;f < filecnt;f++) {
		for(t = argc; t > 1 || (all && t-- == 1);)
			if(all || match((gdir->c_nmloc)->c_name,exstring=argp[--t]))
				if(update && (gdir->c_nmloc)->c_mrecnt != gdir->c_no) continue;
				else {
					if(subing) new = makesub((gdir->c_nmloc)->c_name,newpath);
					else new = (gdir->c_nmloc)->c_name;
					restore(update,(gdir->c_nmloc)->c_name,new);
					mth++;
				}
		gdir = gdir->c_next;
	}
	if(!mth) printf(mtchmesg);
}

expand(as)							/* expand */
char *as;
{
	register char *s, *cs, *dirf;
	char pathname[128];

	s = cs = as;
	while(*cs != '*' && *cs != '?' && *cs != '[')
		if(!*cs++) {
			if(!rfp(as,as)) printf(mtchmesg);
			return;
		}
	while(cs != s && *--cs != '/');

	dirf = pathname;
	if(*cs == '/')
		do *dirf++ = *s++;
		while(s < cs);
	else *dirf++ = '.';
	*dirf++ = 0;
	if(!rfp(pathname,as)) printf(mtchmesg);
}

rfp(pathname,pattern)						/* rfp */
char *pathname, *pattern;
{
	int mth, fildes;
	register char *p, *s, *q;
	char newpath[58];
	char *new, *oldp;
	struct {
		int ino;
		char name[16];
	} entry;

	p = pathname;
	if(pattern && match(p,pattern)) pattern = 0;
	if(stat(p,&stats) < 0) return(0);
	if((stats.flags&IMASK) != IDIR) {
		if(needir) tpsearch(0, 0);
		if(subing) new = makesub(p, newpath);
		else new = p;
		save(update, p, new);
		return(1);
	}

	if(nomount) {
		if(dotminmaj != stats.minmaj) {
			if(verbose&02) printf("%s: mounted\n",p);
			return(0);
		}
	}
	if((fildes = open(p,0)) < 0) return(0);
	if(*p=='.' && !*++p) pathname = p+1;
	if(*p=='/' && !*++p) pathname = p;
	while(*p++);
	--p;
	oldp = p;
	*p++ = '/';
	mth = 0;
	while ((read(fildes,&entry,16))==16) {
		if(!entry.ino || entry.name[0] == '.') continue;
		s = p;
		q = entry.name;
		entry.name[14] = 0;
		while(*s++ = *q++);
		if(!pattern || match(pathname,pattern)) mth=rfp(pathname,0);
	}
	*oldp = 0;
	close(fildes);
	return(mth);
}

preserve()							/* preserve */
{
	register t;

	added = 0;
	if(argc == 1) {
		argp[1] = "*";
		argc++;
	}

	if(nomount) {
		stat(".",&stats);
		dotminmaj = stats.minmaj;
	}
	for(t = argc; t >1;) expand(exstring=argp[--t]);

	printf("%d added, now %d files\n",added,filecnt);
	dumpdir();
}

findup(nam)							/* findup */
char *nam;
{
	register i;
	register struct cdirstr *cd;

	cd = dbuf;

	for(i=filecnt;i;--i)
		if(eq(nam,(cd->c_nmloc)->c_name)) return(gdir = cd);
		else cd = cd->c_next;

	return(0);
}

dswask(na)							/* dswask */
{
	printf("%s  ",na);
	if(yes()) return(1);
	return(0);
}

yes()								/* yes */
{
	register c;

	c = getch();
	if(c != '\n') while(getch() != '\n');
	return(c == 'y');
}

getsize(sgn, szz)						/* getsize */
char sgn, *szz;
{
	register char *sz;
	register sign;

	sizelimit = 0;
	sz = szz;

	if(sgn == '+') sign = 1;
	else sign = -1;

	while(*sz >= '0' && *sz <= '9')
		sizelimit = sizelimit * 10 + *sz++ - '0';

	sizelimit =* sign;
	return(sz);
}

setsub()							/* setsub */
{
	register char *a, *sb;
	register t;
	int sti;
	char subdelim;

	if(argc < 3) error(PFR, synmesg);
	for(t = 0;t < 16;) subtab[t++][0] = 0;
	subing++;
	a = argp[1];
	sb = subdat;

	if(*a == '\'' || *a == '"') subdelim = *a++;
	else subdelim = 0;
	while((*sb = *a++) != subdelim && *sb) sb++;
	if(subdelim != *sb) error(PFR, synmesg);
	*sb = 0;
	sti = 0;
	for(t = 2; t < argc; t++) {
		a = argp[t];
		if((subdelim = *a++) != '\'' && subdelim != '"') continue;
		sb = argp[t];
		while((*sb = *a++) && *sb != subdelim) sb++;
		if(*sb == 0) error(PFR,synmesg);
		subtab[sti][0] = argp[t];
		subtab[sti++][1] = sb - argp[t];
		while(*sb++ = *a++);
	}
	argc--;
	argp++;
}

makesub(matched,new)						/* makesub */
char *matched, *new;
{
	register t;
	register char *a, *n;

	for(t = 0;t < 16; t++) if(exstring == subtab[t][0]) goto go;
	return(matched);

	go:
	a = subdat;
	n = new;
	while(*n = *a++) n++;

	a = matched + subtab[t][1];

	while(*n++ = *a++);

	if(*new == 0) error(PFR, synmesg);
	return(new);
}

redir(ll)							/* redir */
{
	register char *l;
	register append;

	l = ll;
	if(*l == '>') {
		append = 1;
		l++;
	} else append = 0;
	if(*l == 0) return;

	if(append) {
		if((fout = open(l, 1)) < 0) goto creatit;
		seek(fout, 0, 2);
	} else {
		creatit:
		if((fout = creat(l, 0666)) < 0) error(PER, l);
	}
	flush();
}

unixout(l)							/* unixout */
{
	int pip[2];

	if(pipe(pip) < 0) error(PER, "pipe");

	if(procno = fork()) {
		if(procno == -1) error(PFR, tagain);
		if(fout != 1) close(fout);
		fout = dup(pip[1]);
		close(pip[0]);
		close(pip[1]);
		flush();
		return;
	}
	close(0);
	dup(pip[0]);
	if(fout != 1) {
		close(1);
		dup(fout);
	}
	if(fground) {
		signal(2, 0);
		signal(3, 0);
	} else {
		signal(2, 1);
		signal(3, 1);
	}
	execl(shname, "sh", "-c", l, 0);
	exit();
}
