#

/*
 * ps - print out information about processes. 
 * switches:
 * a	all processes
 * e	erase screen first (as best we can)
 * k	use system core dump file
 * l	long form (mostly useless info)
 * q	quick way of getting everything
 * r	repeat display at 5 sec intervals
 * x	including typewriterless processes
 */

#include "/usr/sys/param.h"
#include "/usr/sys/proc.h"
#include "/usr/sys/tty.h"
#include "/usr/sys/user.h"
#include "/usr/sys/buf.h"
#include "/usr/sys/inode.h"
#include "/usr/sys/text.h"

#define NDC11 00
#define NKL11 3
#define NDH11 16
#define NDH11N 8

struct {
	char names[8];
} users[256];
int maxuid;

int curproc;
struct proc *procaddr, *psproc;
struct proc *aproc[NPROC];

struct text *textaddr, *pstext;

struct user u;

struct tty tty;

int	cpu[NPROC][8];
char	com[NPROC][32];
char	found[NPROC];

int	nfound;	/* number of processes found */
int	totproc;
int	totsize;
int	actload;
int	texsize, datsize;

int	nflg;
int	ntty;
int	bflg;
int	lflg;
int	uflg;
int	fflg;
int	dflg;
int	cflg;
int	kflg;
int	xflg;
int	tflg;
int	aflg;
int	rflg;
int	oflg;
int	mem;
int	swap;

#define maxnl 21
struct {
	char name[8];
	int  type;
	char  *value;
} nl[maxnl];

char *vnames[] {
	"_proc", "_dc11","_kl11", "_dh11", "_lp11", "_runout",
	"_tout", "_rktab", "_tmtab", "_xy11", "_swbuf",
	"_buf", "_inode", "_text",
	"_posbuf", "_rrkbuf", "_lbolt",
	"_rtmbuf", "_dp11", "_bsdr", "_cs11",
	0,0
};

int stbuf[257];

char *coref "/dev/mem";
char *swapf "/dev/swap";
char *procf "/dev/kmemp";
char *textf "/dev/kmemt";

int	pmem;
int	tmem;

extern	fout;
int	mtty;
int	mproc;
int	uid;
int	puid;
int	f;

main(argc, argv)
char **argv;
{
	struct proc *p;
	register struct proc *pp;
	register int i, c;
	char *ap;
	extern apcomp();

	nice(-100);	/* fast if su */
	if(--argc>0) {
		--argc;
		ap = *++argv;
		++argv;
		while (*ap) switch (*ap++) {
		case 'x':
			xflg++;
			break;

		case 'a':
			aflg++;
			break;

		case 'o':
			oflg++;
			break;

		case 'n':
			nflg = lflg = cflg = aflg = 1;
			if (ntty = *ap) ap++;
			break;

		case 'b':
			bflg = lflg = cflg = aflg = 1;
			break;

		case 'u':
			uflg = lflg = cflg = aflg = 1;
			if(argc<1)
				err("who?");
			break;

		case 'l':
			lflg++;
			break;

		case 'c':	/* include child times */
			cflg++;
		case 't':
			tflg++;
			break;

		case 'f':
			fflg++;	/* fast as possible */
			break;

		case 'd':
			++dflg;
			break;

		case 'k':
			kflg++;
			break;

		case 'r':
			rflg++;
			break;

		}
	}

/* unless -d (dump) flag is specified initialize from 
 * /etc/ps.symtab rather than the /unix table.
 */
	if((!dflg) && ((f = open("/etc/ps.symtab",0))>=0))
		{
		if(read(f,&nl,sizeof nl) != sizeof nl)
			err("-d needed");
		if(read(f,&users,sizeof users) % sizeof users[0] != 0)
			err("-d needed");
		close(f);
		}
	else
		{
		dneeded:
		for (i=0; i<maxnl; ++i)
			setup(&nl[i], vnames[i]);
		nlist("/unix", nl);
		if (nl[0].type==0) 
			err("No namelist");
		rdusers(users,256); /* read in user names */
		}
	if(dflg)
		{
		if((f=creat("/etc/ps.symtab",0666))<0)
			err("/etc/ps.symtab - can't creat");
		write(f,&nl,sizeof nl);
		write(f,&users,(maxuid+1) * sizeof users[0]);
		printf("maxuid = %d\n",maxuid);
		close(f);
		return;
		}

	if(kflg) {
		coref = procf = textf = *argv;
		fflg++; uflg = 0;
	}
	if ((pmem = open(procf, 0)) < 0) {
		err("No pmem");
	}
	if ((tmem = open(textf,0)) < 0) {
		err("No tmem");
	}
	mem = open(coref, 0);
	if ((swap = open(swapf, 0)) < 0) {
		printf("No swap\n");
		fflg++;
	}

	mtty = ttyn(0);
	mproc= getpid();
	uid = getuid() & 0377;
	fout = dup(1);		/* start buffering */
mainloop:
	fflush(&fout);
	procaddr = nl[0].value;
	if (kflg)
		seek(pmem, procaddr, 0);
	if (read(pmem, &proc[0], sizeof proc) != sizeof proc)
		err("cannot read proc table");
	if (proc[0].p_pid != 0 || proc[1].p_pid != 1)
		err("bad namelist");
	for (i=0; i<NPROC; i++)
		aproc[i] = &proc[i];
	qsort(aproc, NPROC, 2, apcomp);    

	textaddr = nl[13].value;
	if (kflg)
		seek(tmem, textaddr, 0);
	if (read(tmem, &text[0], sizeof text) != sizeof text)
		err("cannot read text table");
	for (i=0; i<NTEXT; i++)
		text[i].x_ccount = 0;

	totproc = totsize = actload = 0;
	for (i=0; i<NPROC; i++) {
		found[i] = 0;
		psproc = pp = aproc[i];
		if (pp->p_stat == 0) continue;
		++totproc;
		totsize =+ pp->p_size;
		if (pp->p_pid!=mproc && (pp->p_stat==SSLEEP||pp->p_stat==SRUN)) {
			if (pp->p_pid > 1) actload =+ pp->p_size;
			if(pstext = pp->p_textp)
				text[pstext-textaddr].x_ccount++;
		} else if (bflg)
			continue;
		c = ttyc(pp->p_ttyp);
		if (pp->p_ppid == 1 && c != '?' && aflg && xflg)
			continue;
		if (nflg && c != ntty)
			continue;
		puid = pp->p_uid & 0377;
		if (uid != puid && aflg == 0)
			continue;
		if(uflg && !uwanted(&users[puid],argc,argv))
			continue;
		nfound++;
		found[i] = 1;
		if (getcpu(&cpu[i])) found[i] =| 2;
		if (getcom(&com[i])) found[i] =| 4;
	}
      if (nfound) {
	if (lflg)
		printf("tty st user        ps shar+priv    wait");
	else
		printf("tty user        ps");
	if(tflg||cflg)
		printf("   cpu");
	printf(" command\n");
	for (i=0; i<NPROC; i++) {
		if (found[i] == 0) continue;
		psproc = pp = aproc[i];
		curproc = procaddr + (pp - &proc[0]);
		fflush(&fout);
		c = ttyc(pp->p_ttyp);
		puid = pp->p_uid & 0377;
		if (lflg || c!=mtty)
			printf("%c:", c);
		else
			printf("  ");
		if (lflg) 
			printf("%2o %c %.8s",
				pp->p_flag,
				" SWRIDT"[pp->p_stat],
				&users[puid]);
		else
			printf("  %.8s",&users[puid]);
		if (oflg)
			printf("(%6o/%6o)", &procaddr[pp-proc], pp->p_pid);
		else
			printf("%6d",  pp->p_pid);
		if (lflg) {
			texsize = 0;
			datsize = pp->p_size;
			if (pstext = pp->p_textp) {
				pstext = &text[pstext-textaddr];
				if (pstext->x_count > 1)
					texsize = pstext->x_size;
				else
					datsize =+ pstext->x_size;
			}
			prsize(texsize, datsize);
			if (pp->p_wchan)
				prwait();
			else
				printf("        ");
		}
		if(tflg||cflg)	/* cpu times */
			if (found[i] & 2) prcpu(&cpu[i]);
		if (pp->p_stat==5)
			printf(" <defunct>");
		else
			if (pp->p_pid!=0)
				if (found[i] & 4) printf(" %.32s", &com[i]);
		printf("\n");
	}
      }

	printf("%d processes;",totproc);
	texsize = 0;
	for (i=0; i<NTEXT; i++)
		if (text[i].x_iptr && text[i].x_count) {
			texsize =+ text[i].x_size;
			if (text[i].x_ccount)
				actload =+ text[i].x_size;
		}
	printf(" %d (of 52) K words active\n", (actload+16)>>5);
	fflush(&fout);
	if (rflg)
		{
		sleep(rflg);
		goto mainloop;
		}
}

apcomp(aa,bb) struct proc **aa, **bb; {
	register struct proc *a, *b;
	register n;
	a = *aa; b = *bb;
	n =  a->p_uid & 0377;
	n =- b->p_uid & 0377;
	if (n) return(n);
	return(a->p_pid - b->p_pid);
}

ttyc(p) struct tty *p;
{
	int n;
	struct { struct tty xdc11[]; };

	n = p - nl[1].value->xdc11;
	if (n>=0 && n<NDC11) {
		return('?');
	}
	n = p - nl[2].value->xdc11;
	if(n>=0 && n<NKL11)
		return((n==0) ? '8' : n-1+'i');
	n = p - nl[3].value->xdc11;
	if(n>=0 && n<NDH11)
		return((n<NDH11N) ? n+'0':n-NDH11N+'a');
	return('?');
}

setup(p, s) char *p, *s;
{
	while (*p++ = *s++);
}

/*
 * print out the command that invoked the process by assuming
 * that the process has not destroyed the arguments passed 
 * it on the top of the stack. read the last disk block of the
 * process to obtain the stack and scan for the end of arg flag
 * (-1) then print everything following if printable.
 */

getcom(comp)
{
	register int *ip;
	register char *cp, *cp1;
	int c, i;

	if(! pread(psproc->p_size - 8, stbuf, 512))
		return(0);
	for (ip = &stbuf[256]; ip > &stbuf[0];) {
		if (*--ip == -1) {
			cp = ip+1;
			if (*cp==0)
				cp++;
			for (cp1 = cp; cp1 < &stbuf[256]; cp1++) {
				c = *cp1;
				if (c==0)
					*cp1 = ' ';
				else if (c < ' ' || c > 0176)
					*cp1 = '?';
			}
			cp1 = comp;
			for (i=0; ++i <= 32; )
				if ((*cp1++ = *cp++) == 0) break;
			return(1);
		}
	}
	return(0);
}

prsize(size1, size2)
{	int t1,t2,t3,t4;
	t1 = size1>>5;
	t2 = (size1&31)*10/32;
	t3 = size2>>5;
	t4 = (size2&31)*10/32;
	if (size1 == 0)
		printf("      %2d.%1d",t3,t4);
	else
		printf(" %2d.%1d+%2d.%1d",t1,t2,t3,t4);
}

 struct {
	int fildes;
	int nleft;
	char *nextp;
	char buffer[512];
 } passwd;

rdusers(un,max) struct {char names[8];} un[]; int max;
{
	int id;
	int i;
	char c;
	char *ptr;
	char name[8];
	char pw[8];
	fopen("/etc/passwd",&passwd);
	while (getwd(name)) {
		getwd(pw);
		id=readn();
		if(id>maxuid)
			maxuid = id;
		if (id<max) {
			ptr = &un[id];
			for (i=0;i<8;++i)
			* ptr ++ = name[i];
		}
		while ((c=getc(&passwd))!='\n' && c!='\0') ; 
	}
	close(passwd.fildes);
}

getwd(name) char name[8];
{	register int i;
	register char c;
	for (i=0;i<8;++i) {
		c=getc(&passwd);
		if(c<=0) return(0);
		if(c==':') break;
		name[i]=c;
	}
	while (i<8)
		name[i++]=' ';
	while (c!=':')
		c=getc(&passwd);
	return(c);
}

readn()
{
	register int n;
	register char c;
	n=0;
	while ((c=getc(&passwd))>='0' && c<='9')
		n = n*10 + c - '0';
	return(n);
}

getcpu(timep) {
	register int *t;
	register i,j;
	t = timep;
	i = &u.u_utime[0];
	j = &u;
	i =- j;
	j = i & 077;
	i =>> 6;
	i =& 01777;
	if (pread(i, stbuf, 16+j) <= 0)
		return(0);
	j =>> 1;
	for (i=0; i<8; i++)
		*t++ = stbuf[i+j];
	return(1);
}

prcpu(timep)
{
	register int time;
	register int *t;
	extern ldivr;
	t = timep;
	ddadd(&t[0], &t[2]);
	if(cflg)
		{
		ddadd(&t[0], &t[4]);
		ddadd(&t[0], &t[6]);
		}
	ldivr = 0;
	time = ldiv(t[0],t[1],HZ*60);
	if(time>999/60)
		{
		if(time>999)
			printf("%4d H",time/60);
		else
			printf("%4d M",time);
		return;
		}
	time = ldiv(t[0],t[1],HZ);
	if(ldivr<0) 
		ldivr = 0;
	printf("%4d.%1d",time,ldivr/(HZ/10));
}

ddadd(dp,sp) int dp[],sp[];
{
	register dl,sl,*ddp;
	ddp = dp;
	dl = ddp[1]; dl =>> 1; dl =& 077777;
	sl =  sp[1]; sl =>> 1; sl =& 077777;
	if ((dl =+ sl) < 0) { ddp[0]++; dl =& 077777; }
	sl = ddp[1]; sl =& 01; if (sp[1] & 01) sl++;
	if (sl == 2) if ((dl =+ 1) < 0) { sl = 0; ddp[0]++; dl =& 077777; }	
	ddp[1] = (dl << 1) + sl;
	ddp[0] =+ sp[0];
}

/*
 * read information from process 
 * addr is displacement from start of process in 32 word blocks
 * length is length to read in bytes
 * buff is where to read into
 */

pread(addr,buff,length)
{
	register int baddr, laddr, mf;

	baddr = 0;
	laddr = 0;
	if (psproc->p_stat!=5 && psproc->p_flag&SLOAD) {
		laddr = psproc->p_addr;
		mf = mem;
	} else {
		if(fflg)
			return(0);
		baddr = psproc->p_addr;
		mf = swap;
	}
	laddr =+ addr;
	baddr =+ laddr>>3;
	laddr = (laddr&07)<<6;
	seek(mf, baddr, 3);
	if(laddr!=0)
		seek(mf, laddr, 1);
	if (read(mf, buff, length) != length)
		return(0);
	return(1);
}

err(s,d) char *s;
{
	extern fout;
	fflush(&fout);
	fout = 2;
	printf("ps: ");
	printf(s,d);
	putchar('\n');
	fflush(&fout);
	exit(1);
}

prwait()
{
	register int w;
	register int i;
	register int k;

	w = psproc->p_wchan;
	i = w - nl[3].value;
	if (i>=0 && ( i =/ sizeof tty) < NDH11) {
		printf("  tty%c  ",i < NDH11N ? i+'0' : i-NDH11N+'a');
		return;
	}
	i = w - nl[2].value;
	if (i>=0 && ( i =/ sizeof tty) < NKL11) {
		printf("  tty%c  ",i== 0 ? '8' : i+'i'-1);
		return;
	}
	/* search for an exact match */
	for (i=0; i< maxnl; ++i)
		if(w==nl[i].value) {
			printf("  %-6.6s",&nl[i].name[1]);
			return;
		}
	/* search for a close match */
	for (i=0; i< maxnl; ++i) {
		k = w - nl[i].value;
		if(k>0 && k<=12) {
			printf("  %-4.4s+%1d",&nl[i].name[1],k);
			return;
		}
	}
	/* search for entry in process table */
	i = w - nl[0].value;
	if(i>=0 && (i =/ sizeof proc[0]) < NPROC) {
		if(w == curproc)
			printf("  wait()");
		else
			printf("  proc%2d",i);
		return;
	}
	/* test if waiting on buf header */
	i = w - nl[11].value;
	if (i>=0 && (i =/ sizeof buf[0]) < NBUF) {
		printf("  buff%2d",i);
		return;
	}
	/* test if waiting on an inode */
	i = w - nl[12].value;
	if (i>=0 && (i =/ sizeof inode[0]) < NINODE) {
		printf("  pipe%2d",i);
		return;
	}
	printf("%8o",w);
}

uwanted(name,argc,argv) char *name; char **argv;
{
	register int i;

	for (i=0; i<argc; ++i)
		if(eqname(name,argv[i]))
			return(1);
	return(0);
}

eqname(s1,s2)
char *s1, *s2;
{
	register int i;
	for(i=0; i<8; ++i)
	if(*s1 == *s2)
		{
		++s1;
		++s2;
		}
	else
		return(*s1==' ' && *s2==0);
	return(1);
}
