#

/* xy11 plotter driver - encoded output version */

#include "../param.h"
#include "../conf.h"
#include "../user.h"

#define	ienable	0100
#define	xyprio	030
#define	xyhwat	200
#define	xylwat	100
#define	xyaddr	0172554
#define	opened	01
#define busy	02
#define init	04
#define raw 	010
#define closed 	020

#define nch 1
#define nx2 2
#define ny1 3
#define ny2 4

#define cup 040
#define cdn 020
#define cyu 010
#define cyd 004
#define cxl 002
#define cxr 001

#define pup 037
#define pdn 036
#define pbch 035
#define pech 034

struct {
	int cc;
	char *cf;
	char *cl;
	char state;
	char next;
	int ax;
	int ay;
	char sx;
	char sy;
	int stepcnt;
	int nmajor;
	int nminor;
	int nrem;
	char major;
	char minor;
} xy11;
struct {
	int xycsr;
	int xydbr;
};

xyopen(dev,flag)
{
	spl5();
	while (xy11.state & closed)
		sleep(&xy11.state, xyprio);
	spl0();
	if (xy11.state)
		{ u.u_error= ENODEV;
		  return;
		}
	xyaddr->xycsr = ienable;
	xy11.state = opened|init|raw;
	xy11.next = 0;
}

xywrite()
{
	register char c;

	while ((c=cpass())>=0) {
		if (xy11.state & init) {
			xy11.state =& ~init;
			if (c == pup || c == pdn) xy11.state =& ~raw;
		}
		if (xy11.state & raw) {
			xyputc(c);
			goto xygo;
		}
		switch(xy11.next) {
			case 0:
				break;
			case nch:
				xy11.next = 0;
				continue;
			case nx2:
				if ((c & 0300)==0100) {
					xy11.ax =| c & 077;
					xy11.next = ny1;
					continue;
				}
				goto xyerr;
			case ny1:
				if ((c & 0300)==0100) {
					xy11.sy = c & 040;
					xy11.ay = (c & 037) << 6;
					xy11.next = ny2;
					continue;
				}
				if ((c & 0340)==0040) {
					xy11.sy = c & 020;
					xy11.ay = c & 017;
					xy11.next = 0;
					if (xyput()) goto xygo;
					continue;
				}
				goto xyerr;
			case ny2:
				if ((c & 0300)==0100) {
					xy11.ay =| c & 077;
					xy11.next = 0;
					if (xyput()) goto xygo;
					continue;
				}
			default:
				goto xyerr;
		}
		switch(c) {
			case pup:
				xyputc(cup);
				goto xygo;
			case pdn:
				xyputc(cdn);
				goto xygo;
			case pbch:
				xy11.next = nch;
				continue;
			case pech:
				continue;
			default:
				if ((c & 0300)==0100) {
					xy11.sx = c & 040;
					xy11.ax = (c & 037) << 6;
					xy11.next = nx2;
					continue;
				}
				if ((c & 0340)==0040) {
					xy11.sx = c & 020;
					xy11.ax = c & 017;
					xy11.next = ny1;
					continue;
				}
			xyerr:
				u.u_error = EIO;
				return;
		}
		xygo:	spl5();
			if ((xy11.state & busy) == 0)
				xystart();
			spl0();
	}
}

xyput() {
	register int ax,ay;
	int nmajor,nminor;
	char major,minor;

	ax = xy11.ax;
	ay = xy11.ay;
	if (ax == 0 && ay == 0) return(0);
	if (ax <= ay) {
		major = xy11.sy ? cyu : cyd;
		minor = xy11.sx ? cxl : cxr;
		nmajor= ay;
		nminor= ax;
	} else {
		major = xy11.sx ? cxl : cxr;
		minor = xy11.sy ? cyu : cyd;
		nmajor= ax;
		nminor= ay;
	}
	minor =| major;
	xyputc(major);
	xyputc(minor);
	xyputc((nmajor >> 6) & 037);
	xyputc(nmajor & 077);
	xyputc((nminor >> 6) & 037);
	xyputc(nminor & 077);
	return(1);
}

xyputc(c) {
	extern lbolt;

	spl5();
	while (xy11.cc >= xyhwat)
		sleep(&xy11, xyprio);
	while (putc(c, &xy11) < 0)
		sleep(&lbolt, xyprio);
	spl0();
}

xystart() {
	register char c;
	register int cc;

	if ((cc = xy11.cc) < 1)
		return;
	if (xy11.state & raw) {
		xyaddr->xydbr = getc(&xy11);
	} else if ((c = *xy11.cf) == cup || c == cdn) {
		xyaddr->xydbr = getc(&xy11);
	} else {
		if (cc < 6)
			return;
		xy11.major = getc(&xy11);
		xy11.minor = getc(&xy11);
		xy11.nmajor = (getc(&xy11) & 037) << 6;
		xy11.nmajor =| getc(&xy11) & 077;
		xy11.nminor = (getc(&xy11) & 037) << 6;
		xy11.nminor =| getc(&xy11) & 077;
		xy11.nrem = xy11.nmajor / 2;
		xy11.stepcnt = xy11.nmajor;
		xyout();
	}
	xy11.state =| busy;
}

xyout() {
	--xy11.stepcnt;
	if ((xy11.nrem =+ xy11.nminor) < xy11.nmajor) {
		xyaddr->xydbr = xy11.major;
	} else {
		xyaddr->xydbr = xy11.minor;
		xy11.nrem =- xy11.nmajor;
	}
}

xyint() {
	if ((xy11.state & raw) == 0 && xy11.stepcnt > 0) {
		xyout();
		return;
	}
	xy11.state =& ~busy;
	xystart();
	if (xy11.state & closed) {
		if ((xy11.state & busy) == 0) {
			while (getc(&xy11) >= 0) ;
			xy11.state = 0;
			xyaddr->xycsr = 0;
			wakeup(&xy11.state);
		}
	} else if (xy11.cc < xylwat || (xy11.state & busy) == 0)
		wakeup(&xy11);
}

xyclose(dev,flag) {
	spl5();
	xy11.state =| closed;
	xystart();
	if ((xy11.state & busy) == 0) {
		xy11.state = 0;
		xyaddr->xycsr = 0;
		wakeup(&xy11.state);
	}
	spl0();
}
